<?php
/*
* IPN abstract class
*/
class ipn_class {
	/** @var */
	var $Provider='';
    var $AcceptedProviders=array('PP','SP','MB','EG','2CO');
    /**@basic infomation for payment*/
    var $PayeeAccount='';
    var $PayerAccount='';
    var $Amount=0;
    var $Quantity=0;
    var $Currency='USD';
    /**The below var is for e-gold!*/
    var $PAYMENT_METAL_ID;
    var $PAYMENT_UNITS;
    /**Trial fee for subscriptions*/
    var $SubsID='';
    var $TrialUnit='D';
    var $TrialAmount=0;
    var $TrialPeriod=0;
    var $SubsUnit='D';
    var $SubsPeriod=0;
    var $SubsAmount=0;
    
    /**speified by the merchat:Moneybookers,Stormpay,E-Gold*/
    var $MerchantTXNID='';
    var $TXNID='';

    /**
    * SP:SecretCode;MB:secretcode;EG:merchants alternate passphrase,
    * Note:please enter the MD5 Code for safe!
    */
    var $MD5AccountPassword='';
    /**Stormpay IPN vars*/
    var $IPNVars='transaction_id|transaction_date|amount';
    
    /**instant,subscriptions,cart,donation*/
    var $PaymentType='';
    
    var $ActionUrl='';
    var $IPNUrl='';
    var $ReturnUrl='';
    var $CancelUrl='';
    var $TestMode=0;
    
    var $IPNTable='records';
    var $EmailTo='ywyhnchina@163.com';
    var $_FormField=array();
    /**hold ipn data*/
    var $_Data=array();
    
	/**
	* ipn class constructor
	*/
	function ipn_class( $Provider )
    {
        if(!in_array($Provider,$this->AcceptedProviders))
        {
            $this->RaiseError("Ipn_class instance error:The provider <b>$_GET[Provider]</b> is not supported now!",'fatal');
        }
        
        $this->Provider=$Provider;
	}
    /**
    * bind database class to ipn_class
    */
    function BindDB(&$db)
    {
        $this->db=$db;
        $this->table=new TABLE($this->db,$this->IPNTable,'record_id');
    }
    /**
    * record some usefull data into IPN_table
    */
    function RecordIPN()
    {
        if($this->Provider=='PP')
        {
            $this->table->provider='PP';
            $this->table->payee_account=$this->PayeeAccount;
            $this->table->payer_account=$this->PayerAccount;
            
            $this->table->amount=$this->Amount;
            $this->table->fee=$this->GetVar('mc_fee');
            $this->table->quantity=$this->Quantity;
            $this->table->currency=$this->GetVar('mc_currency');
            
            $this->table->txn_id=$this->GetTXNID();
            $this->table->payment_status=$this->GetVar('payment_status');
            $this->table->payment_type=$this->GetVar('txn_type');
            $this->table->payment_date=time();
            
            $this->table->item_name=$this->GetVar('item_name');
            $this->table->item_number=$this->GetVar('item_number');

            $this->table->subscr_id=$this->SubsID;
            $this->table->subscr_unit=$this->SubsUnit;
            $this->table->subscr_period=$this->SubsPeriod;
            $this->table->subscr_amount=$this->SubsAmount;
            $this->table->trial_unit=$this->TrialUnit;
            $this->table->trial_period=$this->TrialPeriod;
            $this->table->trial_amount=$this->TrialAmount;

            $this->table->data=serialize($this->_Data);

            $this->table->insert();
            
            $this->RecordID=$this->table->insertid();
        }
        if($this->Provider=='2CO')
        {
            $this->table->provider='2CO';
            $this->table->payee_account=$this->PayeeAccount;
            $this->table->payer_account=$this->PayerAccount;

            $this->table->amount=$this->Amount;
            $this->table->fee=0;
            $this->table->quantity=$this->Quantity;
            $this->table->currency=$this->Currency;

            $this->table->txn_id=$this->GetTXNID();
            $this->table->payment_status=$this->GetVar('x_2checked');
            $this->table->payment_type=$this->PaymentType;
            $this->table->payment_date=time();

            $this->table->item_name=$this->GetVar('x_invoice_num');
            $this->table->item_number=$this->GetVar('x_custom');

            $this->table->data=serialize($this->_Data);

            $this->table->insert();

            $this->RecordID=$this->table->insertid();
        }
        /**
        Update the table
        */
        if($this->Provider=='EG') //only for sigle items purchase!
        {
            $this->table->record_id=$this->GetTXNID();
            
            $this->table->provider='EG';
            $this->table->payee_account=$this->PayeeAccount;
            $this->table->payer_account=$this->PayerAccount;

            $this->table->amount=$this->Amount;
            $this->table->fee=$this->GetVar('FEEWEIGHT');
            $this->table->quantity=1;
            $this->table->currency=$this->GetVar('PAYMENT_UNITS').' '.$this->GetVar('PAYMENT_METAL_ID');

            $this->table->txn_id=$this->GetTXNID();
            $this->table->payment_status='OK';
            $this->table->payment_type='instant';
            $this->table->payment_date=time();
            
            $this->table->data=serialize($this->_Data);

            $this->table->update();
            $this->RecordID=$this->GetTXNID();
        }
        if($this->Provider=='SP')
        {
            $this->table->provider='SP';
            $this->table->payee_account=$this->PayeeAccount;
            $this->table->payer_account=$this->PayerAccount;

            $this->table->amount=$this->Amount;
            $this->table->fee=$this->GetVar('transaction_fee');
            $this->table->quantity=$this->Quantity;
            $this->table->currency='USD';

            $this->table->txn_id=$this->GetTXNID();
            $this->table->txn_ref=$this->MerchantTXNID;
            $this->table->payment_status=$this->GetVar('status');
            $this->table->payment_type=$this->GetVar('subscription')=='YES'?'subscriptions':'instant';
            $this->table->payment_date=time();

            $this->table->item_name=$this->GetVar('product_name');
            $this->table->item_number='';

            $this->table->subscr_ref=$this->GetVar('subscription_ref');

            $this->table->subscr_id=$this->SubsID;
            $this->table->subscr_unit=$this->SubsUnit;
            $this->table->subscr_period=$this->SubsPeriod;
            $this->table->subscr_amount=$this->SubsAmount;
            $this->table->trial_unit=$this->TrialUnit;
            $this->table->trial_period=$this->TrialPeriod;
            $this->table->trial_amount=$this->TrialAmount;
            
            $this->table->data=serialize($this->_Data);

            $this->table->insert();
            
            $this->RecordID=$this->table->insertid();
        }
        if($this->Provider=='MB')
        {
            $this->table->provider='MB';
            $this->table->payee_account=$this->PayeeAccount;
            $this->table->payer_account=$this->PayerAccount;

            $this->table->amount=$this->Amount;
            $this->table->fee=0;
            $this->table->currency=$this->GetVar('currency');

            $this->table->txn_id=$this->GetTXNID();
            $this->table->txn_ref=$this->GetVar('transaction_id');
            $this->table->payment_status=$this->GetVar('status');
            $this->table->payment_type=$this->GetVar('rec_amount')?'subscriptions':'instant';
            $this->table->payment_date=time();

            $this->table->item_name='';
            $this->table->item_number='';

            $this->table->subscr_id=$this->SubsID;
            $this->table->subscr_unit=$this->SubsUnit;
            $this->table->subscr_period=$this->SubsPeriod;
            $this->table->subscr_amount=$this->SubsAmount;
            $this->table->trial_unit=$this->TrialUnit;
            $this->table->trial_period=$this->TrialPeriod;
            $this->table->trial_amount=$this->TrialAmount;

            $this->table->data=serialize($this->_Data);

            $this->table->insert();
            
            $this->RecordID=$this->table->insertid();
        }
    }
    /**
    * assign common url for all gateway
    */
    function AssignUrl($Url)
    {
        $this->IPNUrl=$Url['IPNUrl'];
        $this->ReturnUrl=$Url['ReturnUrl'];
        $this->CancelUrl=$Url['CancelUrl'];
        if($this->Provider=='PP')
        {
            $this->ActionUrl='https://www.'.($this->TestMode==1?'sandbox.':'').'paypal.com/cgi-bin/webscr';
        }
        if($this->Provider=='EG') //only for sigle items purchase!
        {
            $this->ActionUrl='https://www.e-gold.com/sci_asp/payments.asp';
        }
        if($this->Provider=='SP')
        {
            $this->ActionUrl='https://www.stormpay.com/stormpay/handle_gen.php';
        }
        if($this->Provider=='MB')
        {
            $this->ActionUrl='https://www.moneybookers.com/app/payment.pl';
        }
        if($this->Provider=='2CO')
        {
            $this->ActionUrl='https://www.2checkout.com/cgi-bin/sbuyers/cartpurchase.2c';
            $this->ActionUrl='https://www2.2checkout.com/2co/buyer/purchase';
        }
    }
    /**
    * CORE Method
    * check the integrity of data
    * @return bool
    */
    function CheckDataIntegrity()
    {
        if($this->Provider=='PP')
        {
            /**
            *set the callback url
            */
            $this->CallBackUrl='http://www.'.($this->TestMode==1?'sandbox.':'').'paypal.com/cgi-bin/webscr';

            /**
            * collect data to check the integrity against server!
            */
            $Data=$this->_Data;
            $Data['cmd']='_notify-validate';//add a extra var!
            $Response=$this->CallServer($Data);

            if(eregi("VERIFIED",$Response))
            return 1;
            else
            return 0;
            
        }
        if($this->Provider=='2CO')
        {
            /**
            * collect data to check the integrity against server!
            */
            $code = $this->MD5AccountPassword.$this->GetVar('x_Login').($this->TestMode? '1' : $this->GetVar('x_trans_id')).sprintf('%01.2f',$this->GetVar('x_amount'));
            //$code = $this->MD5AccountPassword.$this->GetVar('x_Login').'3569103716129.00';
            $hash = strtoupper(md5($code));
            return $hash == $this->GetVar('x_MD5_Hash');

        }
        if($this->Provider=='MB')
        {
            /**
            * collect data to check the integrity against server!
            */
   	        $mbMD5Hash=  strtoupper(md5($this->GetVar('merchant_id') . $this->GetVar('transaction_id') . strtoupper(md5(strtolower($this->MD5AccountPassword))) . $this->GetVar('mb_amount') . $this->GetVar('mb_currency') . $this->GetVar('status')));

            // if this is secret code
            if(strlen($this->MD5AccountPassword)<11) return $mbMD5Hash == $this->GetVar('md5sig');
            
            /**
            *set the callback url:no test mode!
            */
            $this->CallBackUrl='http://www.moneybookers.com/app/query.pl';

            /**
            * collect data to check the integrity against server!
            */
            $Data=array();
            $Data['email']=$this->PayeeAccount;
            $Data['password']=$this->MD5AccountPassword;
            $Data['action']='status_trn';
            $Data['mb_trn_id']=$this->GetVar('mb_transaction_id');
            
            $Response=$this->CallServer($Data);//get method

            $result = urldecode($Response);
            
            preg_match("/\d{3}/", $result, $return_code);
            
            switch ($return_code[0]) {
            // query was OK, data is sent back
            case "200":
            $result = strstr($result, "status");
            $aResult = explode("&", $result);

            /***********************************************************/
            // get the returned data
            // [status] -- (-2) => failed
            //             ( 2) => processed
            //             ( 1) => scheduled (eg. offline bank transfer)
            // [mb_transaction_id] -- transaction ID at moneybookers.com
            /***********************************************************/
            foreach ($aResult as $value) {
              list($parameter, $pVal) = explode("=", $value);
              $aFinal["$parameter"] = $pVal;
            }

            if ($aFinal["status"] == -2) {
            $this->SetError('Transaction failed.');
            return false;
            } else {
            // if everything went good, update the data in the database and in the order class
            return true;
            }
            
            // error occured during query
            // errors documented in the moneybookers doc
            case "401": case "402": case "403": case "404": case "405":
            preg_match("/[^\d\t]+.*/i", $result, $return_array);

            $this->SetError("ERROR_CODE:: {$return_code[0]}, ERROR:: {$return_array[0]}");
            
            return false;

            // unknown error
            default:
            $this->SetError("ERROR_CODE:: 000, ERROR:: Unknown error!");
            return false;

            }
        }
        if($this->Provider=='SP')
        {
            /**
            * check the secret is correct
            */
            $vars=explode("|",$this->IPNVars);
            $nums=count($vars);
            $pos=intval($nums/2)+1;
            for($i=0;$i<$nums;$i++)
            {
                if($i+2==$pos)
                $rawcode.=$this->_Data[$vars[$i]].':'.$this->MD5AccountPassword.':';
                else
                $rawcode.=$this->_Data[$vars[$i]].':';
            }
            $rawcode=substr($rawcode,0,-1);

            if(MD5($rawcode) == $this->GetVar('secret_code'))
            return 1;
            else
            return 0;
        }
        if($this->Provider=='EG')
        {
            /**
            * build the auth code from post vars from EG
            */
            $AuthCode=$this->GetVar('PAYMENT_ID').':'.$this->GetVar('PAYEE_ACCOUNT').':'.$this->GetVar('PAYMENT_AMOUNT').':'.$this->GetVar('PAYMENT_UNITS').':'.$this->GetVar('PAYMENT_METAL_ID').':'.$this->GetVar('PAYMENT_BATCH_NUM').':'.$this->GetVar('PAYER_ACCOUNT').':'.strtoupper($this->MD5AccountPassword).':'.$this->GetVar('ACTUAL_PAYMENT_OUNCES').':'.$this->GetVar('USD_PER_OUNCE').':'.$this->GetVar('FEEWEIGHT').':'.$this->GetVar('TIMESTAMPGMT');
            $MD5AuthCode=strtoupper(MD5($AuthCode));
            /**
            * check if the data is integraty
            */
            if($MD5AuthCode == $this->GetVar('V2_HASH'))
            return 1;
            else
            return 0;
            
        }
    }
    function IsUniqueTXNID()
    {
        $TXNID=$this->GetTXNID();
        if(!$TXNID) return true;
        $this->db->setQuery("select * from $this->IPNTable where txn_id='".$TXNID."'");
        $this->db->query();
        if($this->db->getNumRows())
        {
            return false;
        }
        else
        {
            return true;
        }
    }
	/**
	* @print html order form
	*/
	function PrintForm($btn)
    {
        $FormHtml='<form action='.$this->ActionUrl.' name=orderform method=post>'."\n";
        foreach($this->_FormField as $Name => $Value)
        {
            $FormHtml.=$this->BuildFormField(array('name'=>$Name,'value'=>$Value));
        }
        $FormHtml.=$this->GenerateSubmitBtn($btn);
        $FormHtml.='</form>'."\n";
        return $FormHtml;
	}
    function AddField($name,$value)
    {
        $this->_FormField[$name]=$value;
    }
    function BuildFormField($field)
    {
        return '<input type=hidden name="'.$field[name].'" value="'.$field[value]."\">\n";
    }
    function GenerateSubmitBtn($btn)
    {
        if($btn[type]=='image')
        return '<input type=image name="'.$btn[name].'" src="'.$btn[value]."\">\n";
        if($btn[type]=='submit')
        return '<input type=submit name="'.$btn[name].'" value="'.$btn[value]."\">\n";
        if($btn[type]=='autosubmit')
        return '<script>document.orderform.submit()</script>';
        
    }
    /**
    * recieve the ipn data from provider,and populate into ipn_class
    */
    function RecieveData()
    {
    global $_SERVER;
        $this->_Data = (strtoupper($_SERVER[REQUEST_METHOD]) == "POST") ? $_POST : $_GET;
        foreach($this->_Data as $k=>$v)
        {
            $this->_IPN_VARS.="$k=>$v\n";
        }
        /**
        * format the common field to provide a unified var
        */
        /**
        * important note:we make the amount hold the common payment's amount or the subscriptions amount
        * so when it is a subscription,the $this->Amount=$this->SubsAmount
        */
        if($this->Provider=='PP')
        {
            $this->PayeeAccount=$this->_Data['receiver_email'];
            $this->PayerAccount=$this->_Data['payer_email'];
            $this->Quantity=$this->_Data['quantity'];
            $this->Amount=$this->_Data['txn_type']=='subscr_payment'||$this->_Data['txn_type']=='web_accept'?$this->_Data['mc_gross']:$this->_Data['mc_amount3'];
            $this->Currency=$this->_Data['mc_currency'];
            if(substr($this->GetVar('txn_type'),0,6)=='subscr')
            {
                $this->PaymentType='subscriptions';
                $this->SubsID=$this->GetVar('subscr_id');
                $this->SubsUnit=substr($this->GetVar('period3'),strpos($this->GetVar('period3'),' ')+1);
                $this->SubsPeriod=substr($this->GetVar('period3'),0,strpos($this->GetVar('period3'),' '));
                $this->SubsAmount=$this->Amount;
            }
            else
            {
                $this->PaymentType='instant';
            }
            if($this->GetVar('txn_type')=='subscr_signup')
            {
                $this->TrialAmount=$this->GetVar('amount1');
                $this->TrialPeriod=substr($this->GetVar('period1'),0,strpos($this->GetVar('period1'),' '));
                $this->TrialUnit=substr($this->GetVar('period1'),strpos($this->GetVar('period1'),' ')+1);
            }
            
        }
        if($this->Provider=='SP')
        {
            $this->PayeeAccount=$this->_Data['payee_email'];
            $this->PayerAccount=$this->_Data['payer_email'];
            $this->Quantity=$this->_Data['quantity'];
            $this->Amount=$this->_Data['subscription']!='YES'?$this->_Data['amount']:$this->_Data['recurrent_charge'];
            //$this->Currency=$this->_Data['currency']; --no such var!
            $this->MerchantTXNID=$this->_Data['transaction_ref'];
            if($this->GetVar('subscription')=='YES')
            {
                $this->PaymentType='subscriptions';
                $this->SubsID=$this->GetVar('subscription_id');
                $this->SubsUnit='D';
                $this->SubsPeriod=$this->GetVar('duration');
                $this->SubsAmount=$this->GetVar('recurrent_charge');
            }
            else
            {
                $this->PaymentType='instant';
            }
            if($this->PaymentType=='subscriptions')
            {
                $this->TrialUnit='D';
                $this->TrialAmount=$this->GetVar('setup_fee');
                $this->TrialPeriod=$this->GetVar('trial_period');
            }
        }

        if($this->Provider=='MB')  //no Quantity provided
        {
            $this->PayeeAccount=$this->_Data['pay_to_email'];
            $this->PayerAccount=$this->_Data['pay_from_email'];
            $this->Amount=$this->_Data['amount'];
            $this->Currency=$this->_Data['currency'];
            $this->MerchantTXNID=$this->_Data['transaction_id'];
            if($this->GetVar('rec_amount'))
            {
                $this->PaymentType='subscriptions';
                $this->Amount=$this->_Data['rec_amount']; //reset the amount to rec_amount
                $this->SubsID='';//no such value in MB!
                $this->SubsUnit='D';
                $this->SubsPeriod=$this->GetVar('rec_period');
                $this->SubsAmount=$this->GetVar('rec_amount');
            }
            else
            {
                $this->PaymentType='instant';
            }
            if($this->PaymentType=='subscriptions')
            {
                $this->TrialAmount=$this->GetVar('mb_amount');
                $this->TrialPeriod=$this->GetVar('rec_period');
                $this->TrialUnit='D';
            }
        }
        //no Quantity provided and no subscription avaiable!
        if($this->Provider=='EG')
        {
            $this->PayeeAccount=$this->_Data['PAYEE_ACCOUNT'];
            $this->PayerAccount=$this->_Data['PAYER_ACCOUNT'];
            $this->Amount=$this->_Data['PAYMENT_AMOUNT'];
            $this->PAYMENT_UNITS = $this->_Data['PAYMENT_UNITS'];
            $this->PAYMENT_METAL_ID = $this->_Data['PAYMENT_METAL_ID'];
            $this->MerchantTXNID=$this->_Data['PAYMENT_ID'];
        }
        //no Quantity provided and no subscription avaiable!
        if($this->Provider=='2CO')
        {
            $this->PayeeAccount=$this->_Data['x_Login'];
            $this->PayerAccount=$this->_Data['x_Email'];
            $this->Amount=$this->_Data['x_amount'];
            $this->PaymentType='instant';
            $this->TestMode = $this->_Data['demo']=='Y';
        }
        return $this->_Data;
    }
    function RaiseError($error,$type)
    {
        $this->SetError("Error:".$error."\n");
        
        if($type=='fatal')
        die('Fatal error:'.$error);
    }
    /**
	* @get txn_id of transaction
	*/
	function GetTXNID() {
        if($this->Provider=='PP')
        {
            return $this->TXNID=$this->GetVar('txn_id');
        }
        if($this->Provider=='2CO')
        {
            return $this->TXNID=$this->GetVar('x_trans_id');
        }
        if($this->Provider=='SP')
        {
            return $this->TXNID=$this->GetVar('transaction_id');
        }
        if($this->Provider=='MB')
        {
            return $this->TXNID=$this->GetVar('mb_transaction_id');
        }
        if($this->Provider=='EG')
        {
            return $this->TXNID=$this->GetVar('PAYMENT_ID');
        }
	}
    /**
    * get the var in post from provider
    */
    function GetVar($name)
    {
        return $this->_Data[$name];
    }
    /**
    * post data to provider
    */
    function CallServer($Data)
    {
        $parts=parse_url($this->CallBackUrl);
        if($parts[scheme]=='https') $ssl=1; else $ssl=0;
        /**
        * default post method
        */
        $this->PostMethod='fso';
         
        if($ssl && function_exists("curl_init"))
        {
            $this->PostMethod='libCurlPost';
        }
        elseif($ssl && extension_loaded("openssl"))
        {
            $this->PostMethod='fso';
        }
        else
        {
            //don't support https,change to http
            $this->CallBackUrl=str_replace("https://","http://",$this->CallBackUrl);
        }
            
        switch($this->PostMethod) {
        case "libCurlPost":
        $result=$this->_libCurlPost($this->CallBackUrl,$Data);
        break;
        case "curl": //cURL via command line
        $result=$this->_curlPost($this->CallBackUrl,$Data);
        break;
        case "fso": //php fsockopen();
        $result=$this->_fsockPost($this->CallBackUrl,$Data);
        break;
        }
        return $result;
    }
    function _curlPost($url,$data)  {

        //build post string
        foreach($data as $i=>$v) {
           $postdata.= $i . "=" . urlencode($v) . "&";
        }

        //execute curl on the command line
        exec("$paypal[curl_location] -d \"$postdata\" $url", $info);

        $info=implode(",",$info);

        return $info;

    }
    //posts transaction data using libCurl
    function _libCurlPost($url,$data)  {

        //build post string
        foreach($data as $i=>$v) {
           $postdata.= $i . "=" . urlencode($v) . "&";
        }
        //post data
        $ch=curl_init();

        curl_setopt($ch,CURLOPT_SSL_VERIFYPEER,FALSE);
        curl_setopt($ch,CURLOPT_URL,$url);
        curl_setopt($ch,CURLOPT_POST,1);
        curl_setopt($ch,CURLOPT_POSTFIELDS,$postdata);

        //Start ob to prevent curl_exec from displaying stuff.
        ob_start();
        curl_exec($ch);

        //Get contents of output buffer
        $info=ob_get_contents();
        curl_close($ch);

        //End ob and erase contents.
        ob_end_clean();

        return $info;

    }

    //posts transaction data using fsockopen.
    function _fsockPost($url,$data) {

        //Parse url
        $web=parse_url($url);

        foreach($data as $i=>$v) {
           $postdata.= $i . "=" . urlencode($v) . "&";
        }

        //Set the port number
        if($web[scheme] == "https") { $web[port]="443";  $ssl="ssl://"; } else { $web[port]="80"; }

        //Create paypal connection
        $fp=@fsockopen($ssl . $web[host],$web[port],$errnum,$errstr,30);

        //Error checking
        if(!$fp) { $this->SetError("$errnum: $errstr"); }

        //Post Data
        else {
            fputs($fp, "POST $web[path] HTTP/1.1\r\n");
            fputs($fp, "Host: $web[host]\r\n");
            fputs($fp, "Content-type: application/x-www-form-urlencoded\r\n");
            fputs($fp, "Content-length: ".strlen($postdata)."\r\n");
            fputs($fp, "Connection: close\r\n\r\n");
            fputs($fp, $postdata . "\r\n\r\n");

            //loop through the response from the server
            while(!feof($fp)) { $info[]=@fgets($fp, 1024); }

            //close fp - we are done with it
            fclose($fp);

            //break up results into a string
            $info=implode(",",$info);

        }
        return $info;
   }
   function SetError($text)
   {
       $this->Errors.=$this->LastError=$text."\n";
   }
   function EmailErrors($notify=0)
   {
   global $email,$user,$db;
       if(!$this->Errors&&$notify==0) return false;
       $email->template->set_filenames(array(
	   'email' => 'payment_error.html')
	   );
       $email->template->assign_vars(array(
       'SITENAME'=>$user->setting[sitename],
       'SUBJECT'=>'Errors on process '.$this->Provider.' IPN Data!',
       'PAYMENT_ERROR'=>$this->Errors,
       'IPN_VARS'=>$this->_IPN_VARS,
       'SQL'=>$db->allSql.$db->_errorMsg ,//.(serialize($this)),
       'EMAIL_SIG'=>$user->setting[emailsign],
       ));
       $email->to($this->EmailTo);
       $email->from($this->EmailTo);

       $email->send('email');
   }
}
?>
