<?php
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
/**
* @package AIHS
* Tag class
*/
class Tag {
    var $tag_table    = 'files';
    var $mod_rewrite  = false;
    var $maxlength    = 64;
    var $debug = 1;
	/**
	* Tag object constructor
	*/
	function Tag(&$db)
    {
        $this->db = $db;
	}
    function filter($tag_names)
    {
        return $this->remove_blank($tag_names);
    }
    function blank($var)
    {
        return ($var != '');
    }
    function remove_blank($string,$sep=',')
    {
        $a = explode($sep,$string);
        foreach($a as $k=>$b)
        {
            if(trim($b)=='') unset($a[$k]);
            else $a[$k]=substr(trim($a[$k]),0,$this->maxlength);
        }
        $a = array_unique($a);
        return implode($sep,$a);
    }
    /**
    * add file ids for per tag name
    *
    * $tags: array of tags to add or update
    * $file_ids: array of file ids to append to every tag name
    */
    function add($tags,$file_id=0)
    {
        # check input
        if(!$file_id) return 0;
        if(!strlen($tags)) return 0;
        $tags = $this->remove_blank($tags);
        $tag_names = split(',',$tags);
        
        # get tags info from table
        $this->db->setQuery("select tags,tag_ids from $this->tag_table where id='$file_id'");
        $this->db->query();
        $tagid_row = $this->db->loadRow();
        $tagids=$this->remove_blank($tagid_row[tag_ids]);

        # get exists tagnames
        $file_tagnames = $newtag_ids = $newtag_names = array();
        if($tagids)
        {
            $this->db->setQuery("select tag_id,tag_name,tag_times from tags where tag_id in ($tagids)");
            $this->db->query();
            $tag_rows = $this->db->loadRowList('tag_id');

            if($tag_rows)
            foreach($tag_rows as $tag_row)
            {
                if(!in_array($tag_row[tag_name],$tag_names))
                {
                    // delete the tag
                    if($tag_row[tag_times]==1)
                    {
                        if($this->debug) echo 'delete '.$tag_row[tag_name].'<br>';
                        $this->deleteTagById($tag_row[tag_id]);
                    }
                    // update the used times
                    else
                    {
                        if($this->debug) echo 'update -1 '.$tag_row[tag_name].'<br>';
                        $this->db->setQuery("update tags set tag_times=tag_times-1 where tag_id='$tag_row[tag_id]'");
                        $this->db->query();
                    }
                }
                else
                {
                    $newtag_ids[]=$tag_row[tag_id];
                }
                $file_tagnames[]=$tag_row[tag_name];
            }
        }
        // new added tags
        foreach($tag_names as $tag_name)
        {
            if(strlen($tag_name)&&!in_array($tag_name,$file_tagnames))
            {
                $this->db->setQuery("select tag_id from tags where tag_name='$tag_name'");
                $this->db->query();
                $tag_row = $this->db->loadRow();
                if($tag_row)
                {
                    if($this->debug) echo 'new update +1'.$tag_name.'<br>';
                    $newtag_ids[]=$tag_row[tag_id];
                    $this->db->setQuery("update tags set tag_times=tag_times+1 where tag_id='$tag_row[tag_id]'");
                    $this->db->query();
                }
                else
                {
                    if($this->debug) echo 'insert '.$tag_name.'<br>';
                    $this->db->setQuery("insert into tags set tag_name='$tag_name',tag_times=1");
                    $this->db->query();
                    $newtag_ids[]=$this->db->insertid();
                }
            }
        }
        
        # build the tag info
        $newtagid_lists = implode(',',$newtag_ids);
        $this->db->setQuery("update $this->tag_table set tags=',$tags,',tag_ids=',$newtagid_lists,' where id='$file_id'");
        $this->db->query();
        
        return $tags;
    }
    
    /**
    * delete the tag name
    *
    * $tag_name: remove the tag name
    */
    function deleteTag($tag_name)
    {
        # delete the tag
        $this->db->setQuery("delete from tags where tag_name='$tag_name'");
        $this->db->query();
    }

    /**
    * delete the tag name by ID
    *
    * $tag_name: remove the tag name
    */
    function deleteTagById($tag_id)
    {
        # delete the tag
        $this->db->setQuery("delete from tags where tag_id='$tag_id'");
        $this->db->query();
    }
    
    /**
    * remove the tag name
    *
    * $tag_name: remove the tag name
    */
    function remove($tag_id,$tag_name)
    {
        if($tag_id==0)
        {
            $this->db->setQuery("select tag_id,tag_name from tags where tag_name='$tag_name'");
            $this->db->query();
            $tag_row = $this->db->loadRow();
            $tag_id = $tag_row[tag_id];
        }

        $this->db->setQuery("select id,tags,tag_ids from $this->tag_table where deleted=0 and tag_ids like '%,$tag_id,%'");
        $this->db->query();
        $file_rows = $this->db->loadRowList();
        foreach($file_rows as $file_row)
        {
            $new_tagids = $this->remove_blank(str_replace(",$tag_id,",',',$file_row[tag_ids]));
            $new_tags = $this->remove_blank(str_replace(",$tag_name,",',',$file_row[tags]));
            $this->db->setQuery("update $this->tag_table set tags=',$new_tags,',tag_ids=',$new_tagids,' where id='$file_row[id]' limit 1");
            $this->db->query();
        }
        
        $this->deleteTagById($tag_id);
    }
    
    /**
    * remove the tag name
    *
    * $tag_name: replace the tag name
    */
    function _replace($tag_id,$tag_name,$newtag_name)
    {
        $this->db->setQuery("select id,tags,tag_ids from $this->tag_table where deleted=0 and tag_ids like '%,$tag_id,%'");
        $this->db->query();
        $file_rows = $this->db->loadRowList();
        foreach($file_rows as $file_row)
        {
            if($this->debug) echo '_replace tagname:'."$tag_name -> $newtag_name";
            $new_tags = str_replace(",$tag_name,",",$newtag_name,",$file_row[tags]);
            $this->db->setQuery("update $this->tag_table set tags='$new_tags' where id='$file_row[id]' limit 1");
            $this->db->query();
        }
    }
    
    /**
    * merge 2 tag names
    *
    * $tag_name: remove the tag name
    */
    function merge($src_tag,$dest_tag)
    {
        # check input
        if(!$src_tag||!$dest_tag||$src_tag==$dest_tag)  return 0;
        
        # fetch src tag info
        $this->db->setQuery("select tag_id,tag_times from tags where tag_name = '$src_tag'");
        $this->db->query();
        $src_tag_row = $this->db->loadRow();
        if(!$src_tag_row[tag_id]) return 0;
        
        # fetch dest tag info
        $this->db->setQuery("select tag_id,tag_times from tags where tag_name = '$dest_tag'");
        $this->db->query();
        $dest_tag_row = $this->db->loadRow();
        if(!$dest_tag_row[tag_id]) return 0;

        # delete src tag
        $this->remove($src_tag_row[tag_id],$src_tag);
        
        # update tags matches in dest tag row
        $this->db->setQuery("select id from $this->tag_table where deleted=0 and tag_ids like '%,$dest_tag_row[tag_id],%'");
        $this->db->query();
        $newtag_times = $this->db->getNumRows();
        $this->db->setQuery("update tags set tag_times='$newtag_times' where tag_name = '$dest_tag'");
        $this->db->query();

        return 1;
    }
    /**
    * rename the tag name
    *
    * $tag_name: remove the tag name
    */
    function rename($tag_name,$new_name)
    {
        # check input
        if(!$tag_name||!$new_name||$tag_name==$new_name)  return 0;

        # if the new tag exists, merge them
        $this->db->setQuery("select tag_id from tags where tag_name = '$new_name'");
        $this->db->query();
        if($this->db->getNumRows())
        {
            return 0;//$this->merge($tag_name,$new_name);
        }

        # if not, fetch source tag, rename it
        $this->db->setQuery("select tag_id from tags where tag_name = '$tag_name'");
        $this->db->query();
        $tag_row = $this->db->loadRow();

        # then rename tag info tags table
        $this->db->setQuery("update tags set tag_name='$new_name' where tag_id = '$tag_row[tag_id]'");
        $this->db->query();
        
        # replace the tag names by new name at file table
        $this->_replace($tag_row[tag_id],$tag_name,$new_name);
        return 1;
    }
    /**
    * rebuild tags from files table
    */
    function rebuild()
    {
        $this->db->setQuery("select tag_id,tag_name from tags");
        $this->db->query();
        $tag_rows = $this->db->loadRowList();
        foreach($tag_rows as $tag_row)
        {
            $this->db->setQuery("select id from $this->tag_table where deleted = 0 and tag_ids like '%,$tag_row[tag_id],%'");
            $this->db->query();
            $tag_times = $this->db->getNumRows();
            
            # then rename tag info tags table
            if($tag_times)
            {
                $this->db->setQuery("update tags set tag_times='$tag_times' where tag_id = '$tag_row[tag_id]'");
                $this->db->query();
            }
            else
            {
                $this->deleteTagById($tag_row[tag_id]);
            }
        }
    }
    function setError($err)
    {
        $this->errors .= $err."\n";
    }
}
?>
