<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
/*
+--------------------------------------------------------------------------
+ Front-end Setting of MFHS
+--------------------------------------------------------------------------
*/

// cookie prexfix for MFHS
$CookiePrefix = 'mfh_';

// Define the image category
$ImageFile         = array('jpg','jpeg','gif','png');
$ImageFile2        = array('bmp','tiff','tif');
$VideoFile         = array('mpeg','mpg','avi','wmv');

// Custom Fields
$CustomFields      = array('descr','password','tags');

// 404 customised page for MFHS: banned user ...
$ServerIPBannedPage = '404.php';

// Username and password limitation
$UsernameCharsFilter = array(
                       '"'=>'',
                       "'"=>'',
                       //'\\'=>'',
                       );
$UsernameMaxLength  = 32;
$UsernameMinLength  = 5;
$UserPassMinLength  = 4;

// File Extensions Associations
$FileExtensions     = array(
'1' => array('jpg','jpeg','png','gif','bmp','psd','tif'), //Images
'2' => array('doc','docx','pdf','xls','txt','rtf','log','wps','ppt'), //Documents
'3' => array('mp3','wma','wav','ra','mid'), //MP3
'4' => array('avi','mpg','mp4','wmv','mov','rm','vob','3gp','mkv','divx','flv'), //Video
'5' => array('exe','com','bat','app'), //Softwares
'6' => array('*'), //other files
);

$FileViewerMode     = array(
'1' => 'inline', //Images
'2' => 'inline', //Documents
'3' => 'inline', //MP3
'4' => 'inline', //Video
'5' => 'download', //Softwares
'6' => 'download', //other files
);

// Cached features: cache dynamical pages into HTML pages and loads them directly without PHP execution
// Required "Cache Site Pages?" enabled in admin panel!
// Experiemental features for INDEX and DOWNLOAD pages!
$CachedPages = array(
//'INDEX', //INDEX page may have some problems in some browser
'DOWNLOAD',
'RULES',
'LOGIN',
'REGISTER',
'REPORT',
'NEWS',
'CONTACTUS',
'LINKTO',
'SERVICES',
'FAQ',
);

// Upload progress bar setting. You can specify the upload bytes unit here
$UploadSpeedUnit = 'KB';
$UploadProgressUnit = 'KB';
$UploadTotalSizeUnit = 'MB';

// show upload window after upload ?
$ShowUploadWindow = 1;

// special chars replace in download urls. For supporting multiple languages ...
$SpecialCharsConvert = array(
    '&#351;'=>'s',
    '&#305;'=>'i',
    );

/*
+--------------------------------------------------------------------------
+ Admin Setting of MFHS
+--------------------------------------------------------------------------
*/
// custom admin directory
$admin_directory = 'admin';

// Use AJAX loading in admin panel
$USE_AJAX = 1;

// admin panel multiple page setting
$ImagesPerPageByDefault  = 20;
$UsersPerPageByDefault   = 10;
$NewsPerPageByDefault    = 10;
$ReportsPerPageByDefault = 10;
$PaymentPerPageByDefault = 10;

// max failed times before CAPTCHA image appears. Stop force hacking!
$MAX_FAIL_TIMES = 3;

// Template files
$MFHSTemplateFiles=array(
'CSS'=>array(
'style.css',
'dhtmlwindow.css',
),

'Header&Footer'=>array(
'header.html',
'footer.html',
'simple_header.html',
),

'Index'=>array(
'index.body.html',
'loginform.inc.html',
'featured.inc.html',
'sitestats.inc.html',
'login.html',
'register.html',
),

'Site Ads'=>array(
'sponsorbox.inc.html',
'siteadtop.inc.html',
'siteadleft.inc.html',
'siteadright.inc.html',
'topadbox.inc.html',
),

'Member area'=>array(
'members.html',
'profile.inc.html',
'setting.inc.html',
'package_info.inc.html',
'upgrade.inc.html',
'bill.inc.html',
'dlhistory.inc.html',
'rewardcenter.inc.html',
'pointhistory.inc.html',
'filelinks.html',
'folders.html',
'folders.inc.html',
'news.inc.html',
'titlenews.inc.html',
'rewards.html',
),

'Download'=>array(
'filewraper.html',
'download.inc.html',
'image.inc.html',
'mp3.inc.html',
'video.inc.html',
'doc.inc.html',
'delete.html',
'report.html',
),

'Upload'=>array(
'uploadform.inc.html',
'uploadoptions.inc.html',
'uploadjs.inc.html',
'downloadlinks.inc.html',
'getlinks.html',
'uploaderror.inc.html',
'uploadoverview.inc.html',
'uploading.html',
'emailform.inc.html',
'emailform2.inc.html',
'progbar.inc.html',
'progbar2.inc.html',
),

'Site'=>array(
'faq.html',
'featured.html',
'sitenews.html',
'rules.html',
'links.html',
'contact.html',
'service.html',
'siteerrors.html',
),

'Syndicate'=>array(
'syndicate.html',
'iframe.html',
'simple_uploadform.html',
'getlinksform.inc.html',
'uploadfield_before.inc.html',
)
);

/*
+--------------------------------------------------------------------------
+ The following setting are fixed.
+ You donot need edit them unless you know exactly what it is.
+--------------------------------------------------------------------------
*/
define('BOOL',     1); // force boolean
define('INT',      2); // force integer
define('UINT',     3); // force unsigned integer
define('NUM',      4); // force number
define('UNUM',     5); // force unsigned number
define('STR',      6); // force trimmed string
define('BRSTR',    7); // force \n to br string
define('NOHTML',   8); // force trimmed string with HTML made safe
define('ARRAY',    9); // force array
define('XSS',      10); // clean XX atatch string
define('CNT',      11); // set custom value
define('CSM',      12); // load custom cleaner function
define('ENUM',     13); // filter enum type
define('DATE',     14); // convert string to time[seconds]

$ThumbFileTypes = array('7z','arj','avi','bat','bin','bmp','dll','doc','gif','hlp','html','htm','iso','jar','jpeg','jpg','mov','mp3','mpeg','pdf','png','ppt','psd','rar','rpm','swf','tar','tif','tiff','txt','wav','wma','wmv','xls','zip');

//borrowed from phpBB
$LANG_TO_MATCH = array(
		'arabic'					=> 'ar([_-][a-z]+)?',
		'bulgarian'					=> 'bg',
		'catalan'					=> 'ca',
		'czech'						=> 'cs',
		'danish'					=> 'da',
		'german'					=> 'de([_-][a-z]+)?',
		'english'					=> 'en([_-][a-z]+)?',
		'estonian'					=> 'et',
		'finnish'					=> 'fi',
		'french'					=> 'fr([_-][a-z]+)?',
		'greek'						=> 'el',
		'spanish_argentina'			=> 'es[_-]ar',
		'spanish'					=> 'es([_-][a-z]+)?',
		'gaelic'					=> 'gd',
		'galego'					=> 'gl',
		'gujarati'					=> 'gu',
		'hebrew'					=> 'he',
		'hindi'						=> 'hi',
		'croatian'					=> 'hr',
		'hungarian'					=> 'hu',
		'icelandic'					=> 'is',
		'indonesian'				=> 'id([_-][a-z]+)?',
		'italian'					=> 'it([_-][a-z]+)?',
		'japanese'					=> 'ja([_-][a-z]+)?',
		'korean'					=> 'ko([_-][a-z]+)?',
		'latvian'					=> 'lv',
		'lithuanian'				=> 'lt',
		'macedonian'				=> 'mk',
		'dutch'						=> 'nl([_-][a-z]+)?',
		'norwegian'					=> 'no',
		'punjabi'					=> 'pa',
		'polish'					=> 'pl',
		'portuguese_brazil'			=> 'pt[_-]br',
		'portuguese'				=> 'pt([_-][a-z]+)?',
		'romanian'					=> 'ro([_-][a-z]+)?',
		'russian'					=> 'ru([_-][a-z]+)?',
		'slovenian'					=> 'sl([_-][a-z]+)?',
		'albanian'					=> 'sq',
		'serbian'					=> 'sr([_-][a-z]+)?',
		'slovak'					=> 'sv([_-][a-z]+)?',
		'swedish'					=> 'sv([_-][a-z]+)?',
		'thai'						=> 'th([_-][a-z]+)?',
		'turkish'					=> 'tr([_-][a-z]+)?',
		'ukranian'					=> 'uk([_-][a-z]+)?',
		'urdu'						=> 'ur',
		'vietnamese'				=> 'vi',
		'chinese_traditional_taiwan'=> 'zh[_-]tw',
		'chinese_simplified'		=> 'zh',
        'farsi'                     => 'fa',
	);
$LANG_TO_CODE = array(
		'arabic'					=> 'ar',
		'bulgarian'					=> 'bg',
		'catalan'					=> 'ca', //? catalan
		'czech'						=> 'cs',
		'danish'					=> 'da',
		'german'					=> 'de',
		'english'					=> 'en',
		'estonian'					=> 'et',
		'finnish'					=> 'fi',
		'french'					=> 'fr',
		'greek'						=> 'el',
		'spanish_argentina'			=> 'esar',
		'spanish'					=> 'es',
		'gaelic'					=> 'gd',
		'galego'					=> 'gl',
		'gujarati'					=> 'gu',
		'hebrew'					=> 'he',
		'hindi'						=> 'hi',
		'croatian'					=> 'hr',
		'hungarian'					=> 'hu',
		'icelandic'					=> 'is',
		'indonesian'				=> 'id',
		'italian'					=> 'it',
		'japanese'					=> 'ja',
		'korean'					=> 'ko',
		'latvian'					=> 'lv',
		'lithuanian'				=> 'lt',
		'macedonian'				=> 'mk',
		'dutch'						=> 'nl',
		'norwegian'					=> 'no',
		'punjabi'					=> 'pa',
		'polish'					=> 'pl',
		'portuguese_brazil'			=> 'br',
		'portuguese'				=> 'pt',
		'romanian'					=> 'ro',
		'russian'					=> 'ru',
		'slovenian'					=> 'sl',
		'albanian'					=> 'sq',
		'serbian'					=> 'sr',
		'slovak'					=> 'sk',
		'swedish'					=> 'sv',
		'thai'						=> 'th',
		'turkish'					=> 'tr',
		'ukranian'					=> 'uk',
		'urdu'						=> 'ur',
		'vietnamese'				=> 'vi',
		'chinese_traditional_taiwan'=> 'tw',
		'chinese_simplified'		=> 'cn',
        'farsi'                     => 'fa',
	);
$CODE_TO_LANG = array(
		'ar'                    => 'arabic',
		'bg'                    => 'bulgarian',
		'ca'					=> 'catalan', //? catalan
		'cs'					=> 'czech',
		'da'					=> 'danish',
		'de'					=> 'german',
		'en'					=> 'english',
		'et'					=> 'estonian',
		'fi'					=> 'finnish',
		'fr'					=> 'french',
		'el'					=> 'greek',
		'esar'			        => 'spanish_argentina',
		'es'					=> 'spanish',
		'gd'					=> 'gaelic',
		'gl'					=> 'galego',
		'gu'					=> 'gujarati',
		'he'					=> 'hebrew',
		'hi'					=> 'hindi',
		'hr'					=> 'croatian',
		'hu'					=> 'hungarian',
		'is'					=> 'icelandic',
		'id'				    => 'indonesian',
		'it'					=> 'italian',
		'jp'					=> 'japanese',
		'ko'					=> 'korean',
		'lv'					=> 'latvian',
		'lt'				    => 'lithuanian',
		'mk'				    => 'macedonian',
		'nl'					=> 'dutch',
		'no'					=> 'norwegian',
		'pa'					=> 'punjabi',
		'pl'					=> 'polish',
		'br'			        => 'portuguese_brazil',
		'pt'			    	=> 'portuguese',
		'ro'					=> 'romanian',
		'ru'					=> 'russian',
		'sl'					=> 'slovenian',
		'sq'					=> 'albanian',
		'sr'					=> 'serbian',
		'sk'					=> 'slovak',
		'sv'					=> 'swedish',
		'th'					=> 'thai',
		'tr'					=> 'turkish',
		'uk'					=> 'ukranian',
		'ur'					=> 'urdu',
		'vi'				    => 'vietnamese',
		'tw'                    => 'chinese_traditional_taiwan',
		'cn'		            => 'chinese_simplified',
        'fa'                    => 'farsi',
	);
$COUNTRY_CODE_TO_MATCH_LANG = array(
		'ar'					=> 'ar([_-][a-z]+)?',
		'bg'					=> 'bg',
		'catalan'			    => 'ca',
		'cz'					=> 'cs',
		'dk'					=> 'da',
		'de'					=> 'de([_-][a-z]+)?',
		'en'					=> 'en([_-][a-z]+)?',
		'ec'					=> 'et',
		'fi'					=> 'fi',
		'fr'					=> 'fr([_-][a-z]+)?',
		'gr'					=> 'el',
		'ar'			        => 'es[_-]ar',
		'es'					=> 'es([_-][a-z]+)?',
		'gaelic'				=> 'gd',
		'galego'				=> 'gl',
		'gujarati'				=> 'gu',
		'hebrew'				=> 'he',
		'hindi'					=> 'hi',
		'hr'					=> 'hr',
		'hu'					=> 'hu',
		'is'					=> 'is',
		'id'			    	=> 'id([_-][a-z]+)?',
		'it'					=> 'it([_-][a-z]+)?',
		'jp'					=> 'ja([_-][a-z]+)?',
		'kr'					=> 'ko([_-][a-z]+)?',
		'lv'					=> 'lv',
		'lt'			    	=> 'lt',
		'mk'			    	=> 'mk',
		'an'				    => 'nl([_-][a-z]+)?',
		'no'					=> 'no',
		//'punjabi'				=> 'pa',
		'pl'					=> 'pl',
		'br'		        	=> 'pt[_-]br',
		'pt'			    	=> 'pt([_-][a-z]+)?',
		'ro'					=> 'ro([_-][a-z]+)?',
		'ru'					=> 'ru([_-][a-z]+)?',
		'si'					=> 'sl([_-][a-z]+)?',
		'al'					=> 'sq',
		//'serbian'				=> 'sr([_-][a-z]+)?',
		'sk'					=> 'sv([_-][a-z]+)?',
		'se'					=> 'sv([_-][a-z]+)?',
		'th'					=> 'th([_-][a-z]+)?',
		'tr'					=> 'tr([_-][a-z]+)?',
		//'ukranian'				=> 'uk([_-][a-z]+)?',
		'urdu'					=> 'ur',
		//'viatnamese'			=> 'vi',
		'tw'                    => 'zh[_-]tw',
		'cn'		            => 'zh',
        'fa'                    => 'fa',
	);

$mime_mapping = array(
        "."      => "application/octet-stream",
        ".xls"   => "application/excel",
        ".hqx"   => "application/macbinhex40",
        ".doc"   => "application/msword",
        ".dot"   => "application/msword",
        ".wrd"   => "application/msword",
        ".pdf"   => "application/pdf",
        ".pgp"   => "application/pgp",
        ".ps"    => "application/postscript",
        ".eps"   => "application/postscript",
        ".ai"    => "application/postscript",
        ".ppt"   => "application/powerpoint",
        ".rtf"   => "application/rtf",
        ".tgz"   => "application/x-gtar",
        ".gtar"  => "application/x-gtar",
        ".gz"    => "application/x-gzip",
        ".php"   => "application/x-httpd-php",
        ".php3"  => "application/x-httpd-php",
        ".js"    => "application/x-javascript",
        ".ppd"   => "application/x-photoshop",
        ".psd"   => "application/x-photoshop",
        ".swf"   => "application/x-shockwave-flash",
        ".swc"   => "application/x-shockwave-flash",
        ".rf"    => "application/x-shockwave-flash",
        ".tar"   => "application/x-tar",
        ".zip"   => "application/zip",
        ".mid"   => "audio/midi",
        ".midi"  => "audio/midi",
        ".kar"   => "audio/midi",
        ".mp2"   => "audio/mpeg",
        ".mp3"   => "audio/mpeg",
        ".mpga"  => "audio/mpeg",
        ".ra"    => "audio/x-realaudio",
        ".wav"   => "audio/wav",
        ".bmp"   => "image/bitmap",
        ".gif"   => "image/gif",
        ".iff"   => "image/iff",
        ".jb2"   => "image/jb2",
        ".jpg"   => "image/jpeg",
        ".jpe"   => "image/jpeg",
        ".jpeg"  => "image/jpeg",
        ".jpx"   => "image/jpx",
        ".png"   => "image/png",
        ".tif"   => "image/tiff",
        ".tiff"  => "image/tiff",
        ".wbmp"  => "image/vnd.wap.wbmp",
        ".xbm"   => "image/xbm",
        ".css"   => "text/css",
        ".txt"   => "text/plain",
        ".htm"   => "text/html",
        ".html"  => "text/html",
        ".xml"   => "text/xml",
        ".mpg"   => "video/mpeg",
        ".mpe"   => "video/mpeg",
        ".mpeg"  => "video/mpeg",
        ".qt"    => "video/quicktime",
        ".mov"   => "video/quicktime",
        ".avi"   => "video/x-ms-video",
        ".divx"  => "video/divx",
        ".flv"   => "video/x-flv",
        ".eml"   => "message/rfc822",
);

$GEOIP_COUNTRY_CODE_TO_NUMBER = array(
"UN" => 0, "AP" => 1, "EU" => 2, "AD" => 3, "AE" => 4, "AF" => 5,
"AG" => 6, "AI" => 7, "AL" => 8, "AM" => 9, "AN" => 10, "AO" => 11,
"AQ" => 12, "AR" => 13, "AS" => 14, "AT" => 15, "AU" => 16, "AW" => 17,
"AZ" => 18, "BA" => 19, "BB" => 20, "BD" => 21, "BE" => 22, "BF" => 23,
"BG" => 24, "BH" => 25, "BI" => 26, "BJ" => 27, "BM" => 28, "BN" => 29,
"BO" => 30, "BR" => 31, "BS" => 32, "BT" => 33, "BV" => 34, "BW" => 35,
"BY" => 36, "BZ" => 37, "CA" => 38, "CC" => 39, "CD" => 40, "CF" => 41,
"CG" => 42, "CH" => 43, "CI" => 44, "CK" => 45, "CL" => 46, "CM" => 47,
"CN" => 48, "CO" => 49, "CR" => 50, "CU" => 51, "CV" => 52, "CX" => 53,
"CY" => 54, "CZ" => 55, "DE" => 56, "DJ" => 57, "DK" => 58, "DM" => 59,
"DO" => 60, "DZ" => 61, "EC" => 62, "EE" => 63, "EG" => 64, "EH" => 65,
"ER" => 66, "ES" => 67, "ET" => 68, "FI" => 69, "FJ" => 70, "FK" => 71,
"FM" => 72, "FO" => 73, "FR" => 74, "FX" => 75, "GA" => 76, "GB" => 77,
"GD" => 78, "GE" => 79, "GF" => 80, "GH" => 81, "GI" => 82, "GL" => 83,
"GM" => 84, "GN" => 85, "GP" => 86, "GQ" => 87, "GR" => 88, "GS" => 89,
"GT" => 90, "GU" => 91, "GW" => 92, "GY" => 93, "HK" => 94, "HM" => 95,
"HN" => 96, "HR" => 97, "HT" => 98, "HU" => 99, "ID" => 100, "IE" => 101,
"IL" => 102, "IN" => 103, "IO" => 104, "IQ" => 105, "IR" => 106, "IS" => 107,
"IT" => 108, "JM" => 109, "JO" => 110, "JP" => 111, "KE" => 112, "KG" => 113,
"KH" => 114, "KI" => 115, "KM" => 116, "KN" => 117, "KP" => 118, "KR" => 119,
"KW" => 120, "KY" => 121, "KZ" => 122, "LA" => 123, "LB" => 124, "LC" => 125,
"LI" => 126, "LK" => 127, "LR" => 128, "LS" => 129, "LT" => 130, "LU" => 131,
"LV" => 132, "LY" => 133, "MA" => 134, "MC" => 135, "MD" => 136, "MG" => 137,
"MH" => 138, "MK" => 139, "ML" => 140, "MM" => 141, "MN" => 142, "MO" => 143,
"MP" => 144, "MQ" => 145, "MR" => 146, "MS" => 147, "MT" => 148, "MU" => 149,
"MV" => 150, "MW" => 151, "MX" => 152, "MY" => 153, "MZ" => 154, "NA" => 155,
"NC" => 156, "NE" => 157, "NF" => 158, "NG" => 159, "NI" => 160, "NL" => 161,
"NO" => 162, "NP" => 163, "NR" => 164, "NU" => 165, "NZ" => 166, "OM" => 167,
"PA" => 168, "PE" => 169, "PF" => 170, "PG" => 171, "PH" => 172, "PK" => 173,
"PL" => 174, "PM" => 175, "PN" => 176, "PR" => 177, "PS" => 178, "PT" => 179,
"PW" => 180, "PY" => 181, "QA" => 182, "RE" => 183, "RO" => 184, "RU" => 185,
"RW" => 186, "SA" => 187, "SB" => 188, "SC" => 189, "SD" => 190, "SE" => 191,
"SG" => 192, "SH" => 193, "SI" => 194, "SJ" => 195, "SK" => 196, "SL" => 197,
"SM" => 198, "SN" => 199, "SO" => 200, "SR" => 201, "ST" => 202, "SV" => 203,
"SY" => 204, "SZ" => 205, "TC" => 206, "TD" => 207, "TF" => 208, "TG" => 209,
"TH" => 210, "TJ" => 211, "TK" => 212, "TM" => 213, "TN" => 214, "TO" => 215,
"TP" => 216, "TR" => 217, "TT" => 218, "TV" => 219, "TW" => 220, "TZ" => 221,
"UA" => 222, "UG" => 223, "UM" => 224, "US" => 225, "UY" => 226, "UZ" => 227,
"VA" => 228, "VC" => 229, "VE" => 230, "VG" => 231, "VI" => 232, "VN" => 233,
"VU" => 234, "WF" => 235, "WS" => 236, "YE" => 237, "YT" => 238, "CS" => 239,
"ZA" => 240, "ZM" => 241, "ZR" => 242, "ZW" => 243, "A1" => 244, "A2" => 245,
"O1" => 246
);
$GEOIP_COUNTRY_CODES = array(
"UN", "AP", "EU", "AD", "AE", "AF", "AG", "AI", "AL", "AM", "AN", "AO", "AQ",
"AR", "AS", "AT", "AU", "AW", "AZ", "BA", "BB", "BD", "BE", "BF", "BG", "BH",
"BI", "BJ", "BM", "BN", "BO", "BR", "BS", "BT", "BV", "BW", "BY", "BZ", "CA",
"CC", "CD", "CF", "CG", "CH", "CI", "CK", "CL", "CM", "CN", "CO", "CR", "CU",
"CV", "CX", "CY", "CZ", "DE", "DJ", "DK", "DM", "DO", "DZ", "EC", "EE", "EG",
"EH", "ER", "ES", "ET", "FI", "FJ", "FK", "FM", "FO", "FR", "FX", "GA", "GB",
"GD", "GE", "GF", "GH", "GI", "GL", "GM", "GN", "GP", "GQ", "GR", "GS", "GT",
"GU", "GW", "GY", "HK", "HM", "HN", "HR", "HT", "HU", "ID", "IE", "IL", "IN",
"IO", "IQ", "IR", "IS", "IT", "JM", "JO", "JP", "KE", "KG", "KH", "KI", "KM",
"KN", "KP", "KR", "KW", "KY", "KZ", "LA", "LB", "LC", "LI", "LK", "LR", "LS",
"LT", "LU", "LV", "LY", "MA", "MC", "MD", "MG", "MH", "MK", "ML", "MM", "MN",
"MO", "MP", "MQ", "MR", "MS", "MT", "MU", "MV", "MW", "MX", "MY", "MZ", "NA",
"NC", "NE", "NF", "NG", "NI", "NL", "NO", "NP", "NR", "NU", "NZ", "OM", "PA",
"PE", "PF", "PG", "PH", "PK", "PL", "PM", "PN", "PR", "PS", "PT", "PW", "PY",
"QA", "RE", "RO", "RU", "RW", "SA", "SB", "SC", "SD", "SE", "SG", "SH", "SI",
"SJ", "SK", "SL", "SM", "SN", "SO", "SR", "ST", "SV", "SY", "SZ", "TC", "TD",
"TF", "TG", "TH", "TJ", "TK", "TM", "TN", "TO", "TP", "TR", "TT", "TV", "TW",
"TZ", "UA", "UG", "UM", "US", "UY", "UZ", "VA", "VC", "VE", "VG", "VI", "VN",
"VU", "WF", "WS", "YE", "YT", "CS", "ZA", "ZM", "ZR", "ZW", "A1", "A2", "O1"
);
$GEOIP_COUNTRY_CODES3 = array(
"UN","AP","EU","AND","ARE","AFG","ATG","AIA","ALB","ARM","ANT","AGO","AQ","ARG",
"ASM","AUT","AUS","ABW","AZE","BIH","BRB","BGD","BEL","BFA","BGR","BHR","BDI",
"BEN","BMU","BRN","BOL","BRA","BHS","BTN","BV","BWA","BLR","BLZ","CAN","CC",
"COD","CAF","COG","CHE","CIV","COK","CHL","CMR","CHN","COL","CRI","CUB","CPV",
"CX","CYP","CZE","DEU","DJI","DNK","DMA","DOM","DZA","ECU","EST","EGY","ESH",
"ERI","ESP","ETH","FIN","FJI","FLK","FSM","FRO","FRA","FX","GAB","GBR","GRD",
"GEO","GUF","GHA","GIB","GRL","GMB","GIN","GLP","GNQ","GRC","GS","GTM","GUM",
"GNB","GUY","HKG","HM","HND","HRV","HTI","HUN","IDN","IRL","ISR","IND","IO",
"IRQ","IRN","ISL","ITA","JAM","JOR","JPN","KEN","KGZ","KHM","KIR","COM","KNA",
"PRK","KOR","KWT","CYM","KAZ","LAO","LBN","LCA","LIE","LKA","LBR","LSO","LTU",
"LUX","LVA","LBY","MAR","MCO","MDA","MDG","MHL","MKD","MLI","MMR","MNG","MAC",
"MNP","MTQ","MRT","MSR","MLT","MUS","MDV","MWI","MEX","MYS","MOZ","NAM","NCL",
"NER","NFK","NGA","NIC","NLD","NOR","NPL","NRU","NIU","NZL","OMN","PAN","PER",
"PYF","PNG","PHL","PAK","POL","SPM","PCN","PRI","PSE","PRT","PLW","PRY","QAT",
"REU","ROU","RUS","RWA","SAU","SLB","SYC","SDN","SWE","SGP","SHN","SVN","SJM",
"SVK","SLE","SMR","SEN","SOM","SUR","STP","SLV","SYR","SWZ","TCA","TCD","TF",
"TGO","THA","TJK","TKL","TLS","TKM","TUN","TON","TUR","TTO","TUV","TWN","TZA",
"UKR","UGA","UM","USA","URY","UZB","VAT","VCT","VEN","VGB","VIR","VNM","VUT",
        "WLF","WSM","YEM","YT","SCG","ZAF","ZMB","ZR","ZWE","A1","A2","O1"
    );
$GEOIP_COUNTRY_NAMES = array(
"Unknown", "Asia/Pacific Region", "Europe", "Andorra", "United Arab Emirates",
"Afghanistan", "Antigua and Barbuda", "Anguilla", "Albania", "Armenia",
"Netherlands Antilles", "Angola", "Antarctica", "Argentina", "American Samoa",
"Austria", "Australia", "Aruba", "Azerbaijan", "Bosnia and Herzegovina",
"Barbados", "Bangladesh", "Belgium", "Burkina Faso", "Bulgaria", "Bahrain",
"Burundi", "Benin", "Bermuda", "Brunei Darussalam", "Bolivia", "Brazil",
"Bahamas", "Bhutan", "Bouvet Island", "Botswana", "Belarus", "Belize",
"Canada", "Cocos (Keeling) Islands", "Congo, The Democratic Republic of the",
"Central African Republic", "Congo", "Switzerland", "Cote D'Ivoire", "Cook
Islands", "Chile", "Cameroon", "China", "Colombia", "Costa Rica", "Cuba", "Cape
Verde", "Christmas Island", "Cyprus", "Czech Republic", "Germany", "Djibouti",
"Denmark", "Dominica", "Dominican Republic", "Algeria", "Ecuador", "Estonia",
"Egypt", "Western Sahara", "Eritrea", "Spain", "Ethiopia", "Finland", "Fiji",
"Falkland Islands (Malvinas)", "Micronesia, Federated States of", "Faroe
Islands", "France", "France, Metropolitan", "Gabon", "United Kingdom",
"Grenada", "Georgia", "French Guiana", "Ghana", "Gibraltar", "Greenland",
"Gambia", "Guinea", "Guadeloupe", "Equatorial Guinea", "Greece", "South Georgia
and the South Sandwich Islands", "Guatemala", "Guam", "Guinea-Bissau",
"Guyana", "Hong Kong", "Heard Island and McDonald Islands", "Honduras",
"Croatia", "Haiti", "Hungary", "Indonesia", "Ireland", "Israel", "India",
"British Indian Ocean Territory", "Iraq", "Iran, Islamic Republic of",
"Iceland", "Italy", "Jamaica", "Jordan", "Japan", "Kenya", "Kyrgyzstan",
"Cambodia", "Kiribati", "Comoros", "Saint Kitts and Nevis", "Korea, Democratic
People's Republic of", "Korea, Republic of", "Kuwait", "Cayman Islands",
"Kazakstan", "Lao People's Democratic Republic", "Lebanon", "Saint Lucia",
"Liechtenstein", "Sri Lanka", "Liberia", "Lesotho", "Lithuania", "Luxembourg",
"Latvia", "Libyan Arab Jamahiriya", "Morocco", "Monaco", "Moldova, Republic
of", "Madagascar", "Marshall Islands", "Macedonia",
"Mali", "Myanmar", "Mongolia", "Macau", "Northern Mariana Islands",
"Martinique", "Mauritania", "Montserrat", "Malta", "Mauritius", "Maldives",
"Malawi", "Mexico", "Malaysia", "Mozambique", "Namibia", "New Caledonia",
"Niger", "Norfolk Island", "Nigeria", "Nicaragua", "Netherlands", "Norway",
"Nepal", "Nauru", "Niue", "New Zealand", "Oman", "Panama", "Peru", "French
Polynesia", "Papua New Guinea", "Philippines", "Pakistan", "Poland", "Saint
Pierre and Miquelon", "Pitcairn Islands", "Puerto Rico", "Palestinian Territory",
"Portugal", "Palau", "Paraguay", "Qatar", "Reunion", "Romania",
"Russian Federation", "Rwanda", "Saudi Arabia", "Solomon Islands",
"Seychelles", "Sudan", "Sweden", "Singapore", "Saint Helena", "Slovenia",
"Svalbard and Jan Mayen", "Slovakia", "Sierra Leone", "San Marino", "Senegal",
"Somalia", "Suriname", "Sao Tome and Principe", "El Salvador", "Syrian Arab
Republic", "Swaziland", "Turks and Caicos Islands", "Chad", "French Southern
Territories", "Togo", "Thailand", "Tajikistan", "Tokelau", "Turkmenistan",
"Tunisia", "Tonga", "East Timor", "Turkey", "Trinidad and Tobago", "Tuvalu",
"Taiwan", "Tanzania, United Republic of", "Ukraine",
"Uganda", "United States Minor Outlying Islands", "United States", "Uruguay",
"Uzbekistan", "Holy See (Vatican City State)", "Saint Vincent and the
Grenadines", "Venezuela", "Virgin Islands, British", "Virgin Islands, U.S.",
"Vietnam", "Vanuatu", "Wallis and Futuna", "Samoa", "Yemen", "Mayotte",
"Serbia and Montenegro", "South Africa", "Zambia", "Zaire", "Zimbabwe",
"Anonymous Proxy","Satellite Provider","Other"
);
?>
