#
# Table structure for table cronlogs
#

CREATE TABLE `cronlogs` (
  `log_id` int(11) unsigned NOT NULL auto_increment,
  `results` text,
  `date` int(11) default NULL,
  `cron_id` varchar(255) default NULL,
  PRIMARY KEY  (`log_id`)
) ENGINE=MyISAM;

#
# Table structure for table crontabs
#

CREATE TABLE `crontabs` (
  `cron_id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `cronscript` varchar(255) default NULL,
  `interval` int(11) default NULL,
  `last_update` int(11) default NULL,
  `enabled` tinyint(1) default '1',
  `multiple` tinyint(1) default '0',
  PRIMARY KEY  (`cron_id`)
) ENGINE=MyISAM;

#
# Dumping data for table crontabs
#

INSERT INTO `crontabs` VALUES (1,'Delete Temp Files','deltmp.php',3600,1166842133,1,1);
INSERT INTO `crontabs` VALUES (2,'Update Download History','cronhistory.php',3600,1166842196,1,0);
INSERT INTO `crontabs` VALUES (3,'Delete files','crondelete.php',3600,1165497441,1,1);
INSERT INTO `crontabs` VALUES (4,'Delete Inactive Accounts','cronaccounts.php',3600,1166521714,0,0);

#
# Table structure for table dlsessions
#

CREATE TABLE `dlsessions` (
  `dl_id` int(11) NOT NULL auto_increment,
  `file_id` int(11) default NULL,
  `uid` int(11) default '0',
  `ip` varchar(32) default '',
  `start_time` int(11) default '0',
  `last_update` int(11) default '0',
  `dl_size` varchar(32) default '0',
  `size` varchar(32) default '0',
  `points` tinyint(3) default '0',
  `threads` int(11) default '1',
  `access_key` varchar(64) default '',
  `server_id` int(11) default NULL,
  `done` tinyint(1) default '0',
  `area` char(2) default 'NA',
  PRIMARY KEY  (`dl_id`),
  KEY `access_key` (`access_key`)
) ENGINE=InnoDB;

#
# Dumping data for table dlsessions
#


#
# Table structure for table downloadhistory
#

CREATE TABLE `downloadhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `date` varchar(8) default NULL,
  `points` int(11) default NULL,
  `downloads` int(11) default NULL,
  `size` bigint(19) default NULL,
  `status` enum('valid','invalid','pend') default 'pend',
  PRIMARY KEY  (`history_id`),
  KEY `uid` (`uid`,`date`)
) ENGINE=MyISAM;

#
# Table structure for table downloadrules
#

CREATE TABLE `downloadrules` (
  `rule_id` int(11) NOT NULL auto_increment,
  `dl_gid` int(11) default NULL,
  `dl_area` text,
  `dl_points` int(11) default NULL,
  `dl_maxbyday` int(11) default NULL,
  `dl_donebytes` varchar(64) default NULL,
  `dl_maxbytes` varchar(64) default NULL,
  `dl_lastupdate` int(11) default NULL,
  PRIMARY KEY  (`rule_id`),
  KEY `dl_gid` (`dl_gid`)
) ENGINE=MyISAM;

#
# Dumping data for table downloadrules
#

INSERT INTO `downloadrules` VALUES (2,1,'UN,CN',2,100000,'316574081','1000000000',1166522504);
INSERT INTO `downloadrules` VALUES (3,3,'UN,CN',3,122222,'238039504','1000000000',1165249060);
INSERT INTO `downloadrules` VALUES (4,2,'UN',1,23,NULL,'1222222222222',1165503359);

#
# Table structure for table faq
#

CREATE TABLE `faq` (
  `faq_id` int(11) unsigned NOT NULL auto_increment,
  `section` varchar(255) default NULL,
  `p_id` int(11) default '0',
  `question` text,
  `answer` text,
  `order` int(11) default NULL,
  `lang` varchar(4) default 'en',
  PRIMARY KEY  (`faq_id`)
) ENGINE=MyISAM;

#
# Dumping data for table faq
#

INSERT INTO `faq` VALUES (2,'Membership',0,NULL,NULL,3,'en');
INSERT INTO `faq` VALUES (3,NULL,2,'How do I sign up for an account?','You can sign up for a free account on the <a href=\"register.php\">sign up</a> page. You need to choose a username and password that you will use to upload images to your account. We also require you to enter a valid email address when you join. We send a confirmation email to this address with instructions on how to activate your account.',NULL,'en');
INSERT INTO `faq` VALUES (5,NULL,2,'Can I sign up for more than 1 account?','Free accounts are limited to 1 (one) per individual. If we catch anyone abusing this limit, we may delete all their accounts without any notice. ',NULL,'en');
INSERT INTO `faq` VALUES (7,'Unanswered Questions',0,NULL,NULL,34,'en');
INSERT INTO `faq` VALUES (12,'File Download Questions',0,NULL,NULL,2,'en');
INSERT INTO `faq` VALUES (13,NULL,2,'How do I access my account?','Once you have <a href=\"register.php\">signed up</a> and confirmed your account, you can <a href=\"login.php\">login</a> to it on the login page. While logged in to your account you can <a href=\"index.php\">Form upload</a>,<a href=\"index.php?uploadmode=2\">URL upload</a> files,>,<a href=\"index.php?uploadmode=3\">FTP upload</a> files, <a href=\"index.php?showlinks=1\">browse</a> the files you have already uploaded, get the urls required to download/delete the files.',NULL,'en');
INSERT INTO `faq` VALUES (15,NULL,12,'What is the maximum allowed size for uploaded files?','The maximum filesize you can upload depends on what account you registered. Files with a larger filesize than the allowed maximum will be rejected. \r\n\r\nYou can view the maximum sizes allowed on our <a href=\"service.php\">service</a> page. ',NULL,'en');
INSERT INTO `faq` VALUES (21,NULL,2,'Help! I\'ve forgotten my username or password.','If you forget your login details for your account we can send a reminder to the email address you registered with us when you created your account. Just follow the instructions on the <a href=\"login.php?act=getpass\">password reminder</a> page. \r\n',NULL,'en');
INSERT INTO `faq` VALUES (22,NULL,2,'How do I upgrade to a paid account?','If you have outgrown the features provided by our free account, you can upgrade to a paid account on the <a href=\"members.php?upgrade=1\">upgrade</a> page. Payments are accepted through <a href=http://paypal.com>PayPal</a>,<a href=\"http://e-gold.com\">E-Gold</a>,<a href=\"moneybookers.com\">Moneybookers</a> and in most cases your account will be upgraded automatically after payment. ',NULL,'en');
INSERT INTO `faq` VALUES (23,NULL,7,'Contact us!','If you have any further questions not answered in this document, please <a href=\"contact.php\">contact</a> us directly. ',NULL,'en');
INSERT INTO `faq` VALUES (24,NULL,12,'Can I resume broken downloads?','Yes, but only if you own a Premium-account.Premium-account support download-accelerators. Those programs support resume of broken files and even segmented downloads. This means, you can download the same file with many streams, resulting in higher download-speed.',NULL,'en');
INSERT INTO `faq` VALUES (26,NULL,12,'Can I delete my uploaded files?','Sure you can! After your upload, you will get two links. The download-link, which you give to everyone you want, and a delete-link, which you keep for yourself. Just click on the delete-link and your file will be deleted immediately.\r\n',NULL,'en');
INSERT INTO `faq` VALUES (27,NULL,12,'Which download accelerators can I use? ','You may use any of the major accelerators, a few popular ones are: Speedget, Download Accelerator Plus, GetRight, FlashGet and GoZilla.\r\n',NULL,'en');
INSERT INTO `faq` VALUES (28,NULL,12,'I have upgrade to Premium account, Why is my download slow?','Please make sure you have enabled cookies on your browser.Since our system recognize Premium download by cookie.Also make sure you do not have software installed, which blocks sending of cookies. Some firewalls for example like to do this.',NULL,'en');


#
# Table structure for table files
#

CREATE TABLE `files` (
  `id` int(11) NOT NULL auto_increment,
  `file` varchar(32) NOT NULL default '',
  `name` varchar(250) NOT NULL default '',
  `uid` int(11) default '0',
  `size` bigint(19) NOT NULL default '0',
  `ip` varchar(16) default NULL,
  `time` int(11) NOT NULL default '0',
  `bandwidth` bigint(19) default '0',
  `downloads` int(11) default '0',
  `lastdownload` int(11) default NULL,
  `server_id` int(11) default NULL,
  `deleted` tinyint(1) default '0',
  `password` varchar(255) default NULL,
  `descr` text,
  `upload_id` varchar(12) NOT NULL default '',
  `delete_id` varchar(4) default '',
  `validate` tinyint(1) default '0',
  `thumb` tinyint(1) default '0',
  `featured` tinyint(1) default '0',
  `upload_session` varchar(32) default NULL,
  `extra_servers` varchar(11) default NULL,
  PRIMARY KEY  (`upload_id`),
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

#
# Table structure for table folders
#

CREATE TABLE `folders` (
  `fid` int(11) NOT NULL auto_increment,
  `uid` int(11) default '0',
  `name` varchar(255) default NULL,
  `descr` text,
  `file_ids` text,
  `password` varchar(32) default NULL,
  `friends` varchar(255) default NULL,
  `admin_password` varchar(32) default NULL,
  PRIMARY KEY  (`fid`)
) ENGINE=MyISAM;


#
# Table structure for table gateway
#

CREATE TABLE `gateway` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `Provider` varchar(20) default NULL,
  `PayeeAccount` varchar(255) default NULL,
  `Currency` varchar(255) default NULL,
  `MD5AccountPassword` varchar(255) default NULL,
  `TestMode` tinyint(4) default '1',
  `Enabled` tinyint(1) default '1',
  `BusinissAccount` varchar(255) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

#
# Dumping data for table gateway
#

INSERT INTO `gateway` VALUES (1,'PP','','USD','0',1,1,'');
INSERT INTO `gateway` VALUES (2,'EG','','USD','',0,0,NULL);
INSERT INTO `gateway` VALUES (3,'MB','','EUR','',0,1,NULL);
INSERT INTO `gateway` VALUES (4,'2CO','',NULL,'',1,1,NULL);

#
# Table structure for table groups
#

CREATE TABLE `groups` (
  `id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(200) default NULL,
  `bandwidth` varchar(255) default '0',
  `sizelimit` varchar(255) default '0',
  `allowed_filetype` text,
  `disabled_filetype` text,
  `show_site_ads` tinyint(1) default '1',
  `show_sponser_ads` tinyint(1) default '1',
  `subscr_unit` enum('D','M','Y') default 'M',
  `subscr_period` varchar(255) default '0',
  `subscr_fee` varchar(255) default '0',
  `payment_type` enum('instant','subscriptions') default 'subscriptions',
  `dl_resume` tinyint(1) default '1',
  `dl_speed` int(11) default '0',
  `dl_upspeed` int(11) default '0',
  `dl_threads` tinyint(3) default '5',
  `dl_ips` int(11) default '0',
  `dl_password` tinyint(1) default '0',
  `dl_waittime` tinyint(3) default '30',
  `dl_captcha` tinyint(1) default '1',
  `dl_timeout` int(11) default '12',
  `dl_maxsbyip` int(11) default '1',
  `dl_sizebyhour` int(11) default '0',
  `dl_maxpointsbyday` int(11) default '0',
  `dl_checkarea` tinyint(1) default '0',
  `dl_direct` tinyint(1) default '0',
  `formupload` tinyint(1) default '1',
  `urlupload` tinyint(1) default '1',
  `ftpupload` tinyint(1) default '1',
  `flashupload` tinyint(1) default '1',
  `max_uploads` int(11) default '1',
  `cron_days` int(11) default '0',
  `cron_views` int(11) default '1',
  `cron_enabled` tinyint(1) default '0',
  `folder` tinyint(1) default '1',
  `guest` tinyint(1) default '0',
  `server_id` int(11) default NULL,
  `validate_type` enum('auto','admin','instant') default 'auto',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;

#
# Dumping data for table groups
#

INSERT INTO `groups` VALUES (1,'Guest','50000000','524288000','','php,exe',1,1,'M','','','subscriptions',1,10000,NULL,5,0,1,2,1,120,1,10000000,NULL,0,0,1,1,1,1,5,30,1,1,0,1,0,'admin');
INSERT INTO `groups` VALUES (2,'Registered','500000000','209715200','','',1,1,'D','','','instant',1,100,NULL,5,100,1,0,1,12,1,0,NULL,0,0,1,1,1,1,5,30,1,1,1,0,0,'auto');
INSERT INTO `groups` VALUES (3,'Premium','0','104857600','','php',1,1,'M','1,3,6,12','129,15,25,50','instant',1,0,NULL,5,10,1,0,0,120,1,0,NULL,0,0,1,1,1,1,5,30,1,1,0,0,0,'auto');

#
# Table structure for table hookpoint
#

CREATE TABLE `hookpoint` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) default '',
  `files` varchar(64) default NULL,
  `lines` int(11) default NULL,
  `env` text,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM;

#
# Dumping data for table hookpoint
#


#
# Table structure for table hooks
#

CREATE TABLE `hooks` (
  `hook_id` int(11) NOT NULL auto_increment,
  `name` varchar(64) default '',
  `location` varchar(128) default '',
  `code` text,
  `vars` varchar(225) default NULL,
  `enabled` tinyint(1) default '1',
  `hook_priority` int(11) default '1',
  `plugin_id` int(11) default '1',
  PRIMARY KEY  (`hook_id`)
) ENGINE=MyISAM;

#
# Table structure for table news
#

CREATE TABLE `news` (
  `news_id` int(11) unsigned NOT NULL auto_increment,
  `title` text,
  `body` text,
  `public` tinyint(1) default '1',
  `start_date` int(11) default NULL,
  `end_date` int(11) default NULL,
  `date` int(11) default NULL,
  `lang` varchar(4) default NULL,
  PRIMARY KEY  (`news_id`)
) ENGINE=MyISAM;

#
# Table structure for table plugins
#

CREATE TABLE `plugins` (
  `plugin_id` int(11) NOT NULL auto_increment,
  `name` varchar(64) default '',
  `descr` varchar(255) default '',
  `version` varchar(12) default '',
  `author` varchar(32) default '',
  `homepage` varchar(128) default '',
  `enabled` int(11) default NULL,
  `dependent` varchar(255) default '',
  `plugin_type` enum('3rd','offical','custom') default 'offical',
  `plugin_priority` int(11) default '1',
  `run_type` enum('eval','function') default 'eval',
  PRIMARY KEY  (`plugin_id`)
) ENGINE=MyISAM;

#
# Table structure for table pointhistory
#

CREATE TABLE `pointhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `promotion_id` int(11) default NULL,
  `points` int(11) default NULL,
  `date` int(11) default NULL,
  `status` enum('complete','pending') default 'pending',
  `type` enum('upgrade','payout') default 'upgrade',
  `user_note` text,
  `admin_note` text,
  PRIMARY KEY  (`history_id`)
) ENGINE=MyISAM;

#
# Table structure for table promotions
#

CREATE TABLE `promotions` (
  `promotion_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `descr` text,
  `source_gid` int(11) default NULL,
  `dest_gid` int(11) default NULL,
  `months` int(11) default NULL,
  `points` int(11) default NULL,
  `money` varchar(11) default NULL,
  `points_fee` int(11) default NULL,
  `note` text,
  `start_date` int(11) default NULL,
  `end_date` int(11) default NULL,
  `expire_date` int(11) default NULL,
  PRIMARY KEY  (`promotion_id`)
) ENGINE=MyISAM;

#
# Dumping data for table promotions
#

INSERT INTO `promotions` VALUES (2,'Registered promotion','Registered promotion description',2,3,1,100,'5',1000,'Registered promotion payout explantion',0,0,0);
INSERT INTO `promotions` VALUES (3,'Premium extend','Premium extend',3,3,1,100,'5',1000,'Premium extend',0,0,0);

#
# Table structure for table records
#

CREATE TABLE `records` (
  `record_id` int(11) unsigned NOT NULL auto_increment,
  `txn_id` varchar(32) default NULL,
  `txn_ref` varchar(255) default NULL,
  `provider` varchar(20) default NULL,
  `item_name` varchar(255) default NULL,
  `item_number` varchar(255) default NULL,
  `amount` varchar(11) default NULL,
  `fee` varchar(11) default NULL,
  `currency` varchar(32) default NULL,
  `quantity` int(11) default NULL,
  `payment_status` varchar(30) default NULL,
  `payment_type` varchar(255) default NULL,
  `pending_reason` varchar(255) default NULL,
  `payment_date` int(11) default NULL,
  `subscr_id` varchar(255) default NULL,
  `subscr_ref` varchar(255) default NULL,
  `subscr_unit` enum('D','M','Y') default NULL,
  `subscr_period` int(11) default NULL,
  `subscr_amount` varchar(11) default NULL,
  `trial_unit` enum('D','M','Y') default NULL,
  `trial_period` int(11) default NULL,
  `trial_amount` varchar(11) default NULL,
  `payee_account` varchar(255) default NULL,
  `payer_account` varchar(255) default NULL,
  `note` text,
  `data` text,
  `uid` int(11) default NULL,
  `descr` text,
  `record_date` int(11) default NULL,
  PRIMARY KEY  (`record_id`)
) ENGINE=MyISAM;

#
# Table structure for table reports
#

CREATE TABLE `reports` (
  `report_id` int(11) unsigned NOT NULL auto_increment,
  `upload_id` varchar(12) character set utf8 default NULL,
  `file_id` int(11) default NULL,
  `username` varchar(32) default NULL,
  `subject` varchar(255) default NULL,
  `problems` varchar(255) default NULL,
  `details` text,
  `date` int(11) default NULL,
  `fullname` varchar(255) default NULL,
  `email` varchar(255) default NULL,
  `IP` varchar(32) default NULL,
  PRIMARY KEY  (`report_id`)
) ENGINE=MyISAM;

#
# Table structure for table server
#

CREATE TABLE `server` (
  `server_id` int(11) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `http` enum('http://','https://') default 'http://',
  `domain` varchar(255) default NULL,
  `cgiurl` varchar(255) default NULL,
  `php_temp_dir` varchar(32) default 'temp',
  `cgi_temp_dir` varchar(32) default 'temp',
  `upload_dir` varchar(32) default 'files',
  `keepext` enum('yes','no') default 'no',
  `iswin` enum('yes','no') default 'yes',
  `lighttpd` tinyint(1) default '0',
  `webspace` varchar(255) default '0',
  `max_webspace` varchar(255) default '0',
  `warn_webspace` varchar(255) default '0',
  `mod_status` varchar(255) default '0,0,0,0',
  `im_path` varchar(64) default NULL,
  `ffmpeg_path` varchar(64) default NULL,
  `mplayer_path` varchar(64) default NULL,
  `hosted` int(11) default '0',
  `dbhost` varchar(255) default NULL,
  `ftp` varchar(255) default NULL,
  `user` varchar(255) default NULL,
  `pass` varchar(255) default NULL,
  `path` text,
  `enabled` tinyint(1) default '0',
  `cgi_prog_mode` enum('syn','ajax') default 'ajax',
  `url_prog_mode` enum('syn','ajax') default 'syn',
  `ftp_prog_mode` enum('syn','ajax') default 'syn',
  PRIMARY KEY  (`server_id`)
) ENGINE=MyISAM;

#
# Table structure for table setting
#

CREATE TABLE `setting` (
  `set_id` int(11) NOT NULL default '0',
  `admin` varchar(32) default NULL,
  `pass` varchar(255) default NULL,
  `pass_salt` varchar(3) default NULL,
  `admin_lastclick` int(11) default NULL,
  `admin_ip` varchar(32) default NULL,
  `reset_date` int(11) default NULL,
  `last_login` int(11) default NULL,
  `last_fail` int(11) default NULL,
  `fail_times` tinyint(3) default '0',
  `max_failtimes` tinyint(4) default '3',
  `adminemail` varchar(100) NOT NULL default '',
  `servermoniter_emails` varchar(255) default NULL,
  `validate` char(1) default '0',
  `banip` mediumtext,
  `sitename` varchar(200) default NULL,
  `server` varchar(11) default '0',
  `language` varchar(255) default '255',
  `lang_page` enum('static','dyn') default 'static',
  `newsletter_subject` varchar(255) default NULL,
  `newsletter_body` text,
  `newsletter_target` varchar(4) default NULL,
  `in_process` tinyint(4) default '0',
  `site_keyword` text,
  `site_descr` text,
  `emailsign` text,
  `skin_dir` varchar(255) default NULL,
  `cached` tinyint(4) default '1',
  `notifyreport` tinyint(1) default '1',
  `site_offline` tinyint(1) default '0',
  `descr` tinyint(1) default '1',
  `password` tinyint(1) default '1',
  `sitestats` tinyint(1) default '1',
  `static_url` enum('dyn','short','seo') default NULL,
  `allow_php` tinyint(1) default '1',
  `shaketime` int(11) default '2000',
  `startshow` int(11) default '2000',
  `adtop` int(11) default '200',
  `adleft` int(11) default '500',
  `slidestep` int(11) default '15',
  `slideinternal` int(11) default '10',
  `show_featured_files` tinyint(1) default '1',
  `show_guest_package` tinyint(1) default '1',
  `thumb_width` int(11) default '165',
  `thumb_height` int(11) default '165',
  `thumb_type` enum('fix','soft') default 'soft',
  `validate_type` enum('auto','admin') default 'auto',
  `featured_type` tinyint(1) default '0',
  `featured_ads` tinyint(3) default NULL,
  `featured_files` int(11) default NULL,
  `featured_users` text,
  `top_page` enum('static','dyn') default 'dyn',
  `download_code` varchar(64) default NULL,
  `check_download_ip` tinyint(1) default '1',
  `download_prefix` varchar(32) default NULL,
  `cache_sessions` tinyint(4) default '1',
  `allow_proxy` tinyint(1) default '0',
  `mfhs_version` varchar(64) default NULL,
  `main` tinyint(1) default '1',
  `debug` enum('yes','no') default 'no',
  `admin_charset` varchar(32) default 'UTF-8',
  `report_captcha` tinyint(1) default '0',
  `contact_captcha` tinyint(1) default '0',
  `show_options` tinyint(1) default '1',
  `expired_package` int(11) default NULL,
  `use_flash_progress` tinyint(1) default '0',
  `inline_crontab` tinyint(1) default '1',
  `last_stats` varchar(64) default NULL,
  PRIMARY KEY  (`set_id`)
) ENGINE=MyISAM;

#
# Dumping data for table setting
#

INSERT INTO `setting` VALUES (1,'admin','d9b1d7db4cd6e70935368a1efb10e377',NULL,1166850868,'127.0.0.1',1166338908,1166842671,1166800713,0,123,'','','0','','Mega File Hosting Script','0','-1','dyn','subject','body','',0,'hosting, webhosting, webspace, webserver, backup, file exchange, bandwidth, free download, free downloads, free upload, upload, uploading, download, downloads, mp3, movies, music, videos, shareware, remote desktop, file synchronization, flirt, download movies, spyware remover, firewall software download, chatroom, file transfer, software downloads, file sharing, music downloads, webcam, file mirroring, free software downloads, photoshop, paint shop, download, music downloading, toolbar, playlist, music, kiss tips, file recovery, toner cartridge, edonkey, emule, spyware free download, Singles, ecards, free download, free video, digital photos, free music, photos, video download','The best file hosting service! we provides free web space for your documents, pictures, music and movies.','changme.com','blue',1,1,0,1,1,0,'dyn',0,2000,2000,200,500,15,10,1,0,165,165,'soft','auto',1,1,6,NULL,NULL,'mycodehere',1,'[yabsoft]',1,0,NULL,1,'no','UTF-8',1,1,0,2,0,1,NULL);

#
# Table structure for table users
#

CREATE TABLE `users` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `user` varchar(255) default NULL,
  `pass` varchar(255) default NULL,
  `email` varchar(255) default NULL,
  `bandwidth` varchar(255) default '0',
  `webspace` varchar(255) default '0',
  `files` int(11) default '0',
  `totaldownloads` bigint(19) NOT NULL default '0',
  `totalpoints` varchar(32) default '0',
  `gid` int(11) default NULL,
  `status` tinyint(4) default '1',
  `regdate` int(11) default NULL,
  `subscr_id` varchar(255) default NULL,
  `subscr_unit` enum('D','M','Y') default NULL,
  `subscr_period` int(11) default NULL,
  `subscr_fee` varchar(10) default NULL,
  `expire_date` int(11) default '0',
  `payment_type` enum('instant','subscriptions') default NULL,
  `referby` int(11) default NULL,
  `last_login` int(11) default NULL,
  `last_update` int(11) default NULL,
  `last_remove` tinyint(4) default NULL,
  `custom` enum('yes','no') default 'no',
  `data` text,
  `validate_code` varchar(32) default NULL,
  `sent` tinyint(4) default '0',
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM;
