CREATE TABLE `cronlogs` (
  `log_id` int(11) unsigned NOT NULL auto_increment,
  `results` text,
  `date` int(11) default NULL,
  `cron_id` varchar(255) default NULL,
  PRIMARY KEY  (`log_id`)
) ENGINE=MyISAM;
CREATE TABLE `crontabs` (
  `cron_id` int(6) unsigned NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `cronscript` varchar(255) default NULL,
  `interval` int(11) default NULL,
  `last_update` int(11) default NULL,
  `enabled` tinyint(1) default '1',
  `multiple` tinyint(1) default '0',
  PRIMARY KEY  (`cron_id`)
) ENGINE=MyISAM;
CREATE TABLE `downloadhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `date` varchar(8) default NULL,
  `points` int(11) default NULL,
  `downloads` int(11) default NULL,
  `size` bigint(19) default NULL,
  `status` enum('valid','invalid','pend') default 'pend',
  PRIMARY KEY  (`history_id`),
  KEY `uid` (`uid`,`date`)
) ENGINE=MyISAM;
CREATE TABLE `downloadrules` (
  `rule_id` int(11) NOT NULL auto_increment,
  `dl_gid` int(11) default NULL,
  `dl_area` text,
  `dl_points` int(11) default NULL,
  `dl_maxbyday` int(11) default NULL,
  `dl_donebytes` varchar(64) default NULL,
  `dl_maxbytes` varchar(64) default NULL,
  `dl_lastupdate` int(11) default NULL,
  PRIMARY KEY  (`rule_id`),
  KEY `dl_gid` (`dl_gid`)
) ENGINE=MyISAM;
CREATE TABLE `folders` (
  `fid` int(11) NOT NULL auto_increment,
  `uid` int(11) default '0',
  `name` varchar(255) default NULL,
  `descr` text,
  `file_ids` text,
  `password` varchar(32) default NULL,
  `friends` varchar(255) default NULL,
  `admin_password` varchar(32) default NULL,
  PRIMARY KEY  (`fid`)
) ENGINE=MyISAM;
CREATE TABLE `hookpoint` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(128) default '',
  `files` varchar(64) default NULL,
  `lines` int(11) default NULL,
  `env` text,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM;
CREATE TABLE `hooks` (
  `hook_id` int(11) NOT NULL auto_increment,
  `name` varchar(64) default '',
  `location` varchar(128) default '',
  `code` text,
  `vars` varchar(225) default NULL,
  `enabled` tinyint(1) default '1',
  `hook_priority` int(11) default '1',
  `plugin_id` int(11) default '1',
  PRIMARY KEY  (`hook_id`)
) ENGINE=MyISAM;
CREATE TABLE `plugins` (
  `plugin_id` int(11) NOT NULL auto_increment,
  `name` varchar(64) default '',
  `descr` varchar(255) default '',
  `version` varchar(12) default '',
  `author` varchar(32) default '',
  `homepage` varchar(128) default '',
  `enabled` int(11) default NULL,
  `dependent` varchar(255) default '',
  `plugin_type` enum('3rd','offical','custom') default 'offical',
  `plugin_priority` int(11) default '1',
  `run_type` enum('eval','function') default 'eval',
  PRIMARY KEY  (`plugin_id`)
) ENGINE=MyISAM;
CREATE TABLE `pointhistory` (
  `history_id` int(11) NOT NULL auto_increment,
  `uid` int(11) default NULL,
  `promotion_id` int(11) default NULL,
  `points` int(11) default NULL,
  `date` int(11) default NULL,
  `status` enum('complete','pending') default 'pending',
  `type` enum('upgrade','payout') default 'upgrade',
  `user_note` text,
  `admin_note` text,
  PRIMARY KEY  (`history_id`)
) ENGINE=MyISAM;
CREATE TABLE `promotions` (
  `promotion_id` int(11) NOT NULL auto_increment,
  `name` varchar(255) default NULL,
  `descr` text,
  `source_gid` int(11) default NULL,
  `dest_gid` int(11) default NULL,
  `months` int(11) default NULL,
  `points` int(11) default NULL,
  `money` varchar(11) default NULL,
  `points_fee` int(11) default NULL,
  `note` text,
  `start_date` int(11) default NULL,
  `end_date` int(11) default NULL,
  `expire_date` int(11) default NULL,
  PRIMARY KEY  (`promotion_id`)
) ENGINE=MyISAM;
INSERT INTO `crontabs` VALUES (1,'Delete Temp Files','deltmp.php',3600,1168312464,1,1);
INSERT INTO `crontabs` VALUES (2,'Update Download History','cronhistory.php',3600,1168312467,1,0);
INSERT INTO `crontabs` VALUES (3,'Delete files','crondelete.php',3600,1168312467,1,1);
INSERT INTO `crontabs` VALUES (4,'Delete Inactive Accounts','cronaccounts.php',3600,1168312467,0,0);
ALTER TABLE `dlsessions` ADD `uid` int(11)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `last_update` int(11)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `dl_size` varchar(32)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `size` varchar(32)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `points` tinyint(3)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `server_id` int(11)  DEFAULT NULL;
ALTER TABLE `dlsessions` ADD `done` tinyint(1)  DEFAULT '0';
ALTER TABLE `dlsessions` ADD `area` char(2)  DEFAULT 'NA';
ALTER TABLE `dlsessions` ADD  INDEX `access_key` (`access_key`);
ALTER TABLE `faq` ADD `lang` varchar(4)  DEFAULT 'en';
ALTER TABLE `files` ADD `bandwidth` bigint(19)  DEFAULT '0';
ALTER TABLE `files` ADD `extra_servers` varchar(11)  DEFAULT NULL;
ALTER TABLE `files` ADD PRIMARY KEY (`upload_id`);
ALTER TABLE `files` ADD  INDEX `uid` (`uid`);
ALTER TABLE `groups` ADD `dl_upspeed` int(11)  DEFAULT '0';
ALTER TABLE `groups` ADD `dl_maxsbyip` int(11)  DEFAULT '1';
ALTER TABLE `groups` ADD `dl_sizebyhour` int(11)  DEFAULT '0';
ALTER TABLE `groups` ADD `dl_maxpointsbyday` int(11)  DEFAULT '0';
ALTER TABLE `groups` ADD `dl_checkarea` tinyint(1)  DEFAULT '0';
ALTER TABLE `groups` ADD `dl_direct` tinyint(1)  DEFAULT '0';
ALTER TABLE `news` ADD `lang` varchar(4)  DEFAULT NULL;
ALTER TABLE `reports` ADD `file_id` int(11)  DEFAULT NULL;
ALTER TABLE `reports` ADD `username` varchar(32)  DEFAULT NULL;
ALTER TABLE `server` ADD `http` enum('http://','https://')  DEFAULT 'http://';
ALTER TABLE `server` ADD `php_temp_dir` varchar(32)  DEFAULT 'temp';
ALTER TABLE `server` ADD `cgi_temp_dir` varchar(32)  DEFAULT 'temp';
ALTER TABLE `server` ADD `upload_dir` varchar(32)  DEFAULT 'files';
ALTER TABLE `server` ADD `keepext` enum('yes','no')  DEFAULT 'no';
ALTER TABLE `server` ADD `iswin` enum('yes','no')  DEFAULT 'yes';
ALTER TABLE `server` ADD `lighttpd` tinyint(1)  DEFAULT '0';
ALTER TABLE `server` ADD `mod_status` varchar(255)  DEFAULT '0,0,0,0';
ALTER TABLE `server` ADD `im_path` varchar(64)  DEFAULT NULL;
ALTER TABLE `server` ADD `ffmpeg_path` varchar(64)  DEFAULT NULL;
ALTER TABLE `server` ADD `mplayer_path` varchar(64)  DEFAULT NULL;
ALTER TABLE `server` ADD `cgi_prog_mode` enum('syn','ajax')  DEFAULT 'ajax';
ALTER TABLE `server` ADD `url_prog_mode` enum('syn','ajax')  DEFAULT 'syn';
ALTER TABLE `server` ADD `ftp_prog_mode` enum('syn','ajax')  DEFAULT 'syn';
ALTER TABLE `setting` ADD `pass_salt` varchar(3)  DEFAULT NULL;
ALTER TABLE `setting` ADD `reset_date` int(11)  DEFAULT NULL;
ALTER TABLE `setting` ADD `last_fail` int(11)  DEFAULT NULL;
ALTER TABLE `setting` ADD `fail_times` tinyint(3)  DEFAULT '0';
ALTER TABLE `setting` ADD `max_failtimes` tinyint(4)  DEFAULT '3';
ALTER TABLE `setting` ADD `lang_page` enum('static','dyn')  DEFAULT 'static';
ALTER TABLE `setting` ADD `show_guest_package` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `thumb_type` enum('fix','soft')  DEFAULT 'soft';
ALTER TABLE `setting` ADD `featured_users` text  DEFAULT NULL;
ALTER TABLE `setting` ADD `top_page` enum('static','dyn')  DEFAULT 'dyn';
ALTER TABLE `setting` ADD `download_code` varchar(64)  DEFAULT NULL;
ALTER TABLE `setting` ADD `check_download_ip` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `download_prefix` varchar(32)  DEFAULT NULL;
ALTER TABLE `setting` ADD `cache_sessions` tinyint(4)  DEFAULT '1';
ALTER TABLE `setting` ADD `allow_proxy` tinyint(1)  DEFAULT '0';
ALTER TABLE `setting` ADD `mfhs_version` varchar(64)  DEFAULT NULL;
ALTER TABLE `setting` ADD `main` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `debug` enum('yes','no')  DEFAULT 'no';
ALTER TABLE `setting` ADD `admin_charset` varchar(32)  DEFAULT 'UTF-8';
ALTER TABLE `setting` ADD `report_captcha` tinyint(1)  DEFAULT '0';
ALTER TABLE `setting` ADD `contact_captcha` tinyint(1)  DEFAULT '0';
ALTER TABLE `setting` ADD `show_options` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `expired_package` int(11)  DEFAULT NULL;
ALTER TABLE `setting` ADD `use_flash_progress` tinyint(1)  DEFAULT '0';
ALTER TABLE `setting` ADD `inline_crontab` tinyint(1)  DEFAULT '1';
ALTER TABLE `setting` ADD `last_stats` varchar(64)  DEFAULT NULL;
ALTER TABLE `setting` ADD PRIMARY KEY (`set_id`);
ALTER TABLE `users` ADD `webspace` bigint(19)  DEFAULT '0';
ALTER TABLE `users` ADD `totaldownloads` bigint(19) NOT NULL default '0';
ALTER TABLE `users` ADD `totalpoints` varchar(32)  DEFAULT '0';
ALTER TABLE `users` ADD `last_update` int(11)  DEFAULT NULL;
ALTER TABLE `users` ADD `last_remove` tinyint(4)  DEFAULT NULL;
ALTER TABLE `users` CHANGE COLUMN `files` `files` int(11) NULL DEFAULT 0;
ALTER TABLE `users` CHANGE COLUMN `bandwidth` `bandwidth` varchar(255) NULL DEFAULT '0';
ALTER TABLE `dlsessions` CHANGE `start_time` `start_time` int(11)  DEFAULT '0';
ALTER TABLE `dlsessions` CHANGE `access_key` `access_key` varchar(64)  DEFAULT '';
ALTER TABLE `files` CHANGE `id` `id` int(11) NOT NULL;
ALTER TABLE `files` CHANGE `file` `file` varchar(32) NOT NULL DEFAULT '';
ALTER TABLE `files` CHANGE `uid` `uid` int(11)  DEFAULT '0';
ALTER TABLE `files` CHANGE `size` `size` bigint(19) NOT NULL DEFAULT '0';
ALTER TABLE `files` CHANGE `ip` `ip` varchar(16)  DEFAULT NULL;
ALTER TABLE `files` CHANGE `upload_id` `upload_id` varchar(12) NOT NULL DEFAULT '';
ALTER TABLE `files` CHANGE `delete_id` `delete_id` varchar(4)  DEFAULT '';
ALTER TABLE `files` CHANGE `id` `id` int(11) NOT NULL auto_increment;
ALTER TABLE `groups` CHANGE `max_uploads` `max_uploads` int(11)  DEFAULT '1';
ALTER TABLE `groups` CHANGE `cron_views` `cron_views` int(11)  DEFAULT '1';
ALTER TABLE `reports` CHANGE `upload_id` `upload_id` varchar(12)  DEFAULT NULL;
ALTER TABLE `reports` CHANGE COLUMN `upload_id` `upload_id` varchar(12) CHARACTER SET 'utf8' NULL;
ALTER TABLE `setting` CHANGE `set_id` `set_id` int(11) NOT NULL DEFAULT '0';
ALTER TABLE `setting` CHANGE `validate` `validate` char(1)  DEFAULT '0';
ALTER TABLE `users` CHANGE `bandwidth` `bandwidth` int(11)  DEFAULT '0';
ALTER TABLE `users` CHANGE `gid` `gid` int(11)  DEFAULT NULL;
