<?
/*
+--------------------------------------------------------------------------
|   Mega File Hosting Script v1.5 by 0m1d
|   ========================================
|   by Stephen Yabziz
|   (c) 2005-2006 YABSoft Services
|   http://www.yabsoft.com
|   ========================================
|   Web: http://www.P30vel.ir
|   Email: info@p30vel.ir
+--------------------------------------------------------------------------
|
|   > Script written by Stephen Yabziz
|   > Date started: 1th March 2006
+--------------------------------------------------------------------------
*/
##
# The code that deals with calculating elapsed time, time remaining
# and upload speed were contributed by Orest Kinasevych
##

# status codes = 0-uploading, 1-started, 2- complete
error_reporting  (E_ERROR | E_WARNING | E_PARSE );
include 'config.php';
include_once('includes/plugin.class.php');
include_once('includes/function.php');
$YABPlugin=& YABPlugin::init();
include 'includes/upload.class.php';

# initiate the class
$uploader = new uploader($server_id);

# sanitize input
$iMode     = intval($_GET['iMode']);
$sessionid = preg_replace('/[^A-Za-z0-9]/','',$_GET['sessionid']);
$iTotal    = intval($_GET['iTotal']);
$iRead     = intval($_GET['iRead']);
$status    = intval($_GET['iStatus']);
$lastRead  = $iRead;
$callback  = preg_replace('/[^A-Za-z0-9]/','',$_GET[callback]);

$uploader->temp_dir = $iMode==1 ? $cgi_temp_dir : $php_temp_dir;
$uploader->upload_session = $sessionid;
$uploader->upload_mode = $iMode;

# system used file
$data_file    = $uploader->temp_dir .'/'.$uploader->upload_session.'_postdata';
$monitor_file = $uploader->temp_dir .'/'.$uploader->upload_session.'_flength';
$progress_file= $uploader->temp_dir .'/'.$uploader->upload_session.'_progress';
$signal_file  = $uploader->temp_dir .'/'.$uploader->upload_session.'_signal';

##
# Get values assigned for current time and upload start time
##
$dtnow   = time();
$dtnow   = intval($_GET['dtnow'])>0 ? intval($_GET['dtnow']) : $dtnow;
$dtstart = intval($_GET['dtstart'])>0 ? intval($_GET['dtstart']) : $dtnow;

##
# The values for iStatus are
#	0 - in progress
#	1 - New upload
#	2 - Complete
##

header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header('Cache-Control: no-store, no-cache, must-revalidate');
header('Cache-Control: post-check=0, pre-check=0', FALSE);
header('Pragma: no-cache');

# APC function to get progress information
function fetch_upload_info($progress_key)
{
   $status = apc_fetch('upload_'.$progress_key);
   return ($status);
}
if(defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1)
{
    $statusinfo = fetch_upload_info($uploader->upload_session);
    //trace_write('temp/PHPUPLOADMODULE_'.$sessionid.'.txt',$statusinfo);
}

if($status == 1)
{
	#new upload starting
	show_starting();
}
elseif($status ==0)
{
	##
	# in progress
	# we will try to read in the total size of data to be transfered from the
	# shared file. It will also tell us how much data has been transfered upto
	# now.
	##
    $bRead = readUploadSize($iNums);
    $iRead = $bRead;
    
    calculateProgress($iTotal,$iRead,$dtstart);

 	make_progress_bar();
	exit;
}
else
{
	show_complete();
}


function readFlength()
{
global $monitor_file;
    #phpupload module
    if(defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1)
    {
        global $statusinfo;
        return $statusinfo['total'];
    }
    
	if(file_exists($monitor_file))
	{
        $lines  = @file($monitor_file);
		$iTotal = $lines[0];
		return $iTotal;
	}
	return 0;

}
function readUploadSize($nums=0)
{
global $progress_file,$lastRead,$fileName;
    #phpupload module
    if(defined('PHPUPLOADMODULE')&&PHPUPLOADMODULE==1)
    {
        global $statusinfo;
        $fileName = $statusinfo['filename'];
        return $statusinfo['current'];
    }
    
    clearstatcache();
    if(file_exists($progress_file))
	{
        $lines  = @file($progress_file);
		list($iRead,$fileName) = split(':',$lines[0]);
        return $lastRead<$iRead ? $iRead : $lastRead;
	}
	return 0;

    $total =0;
    if($nums==0) $total = @filesize($data_file);

    for($i=1;$i<=$nums;$i++)
	#if(file_exists($data_file.$i))
	{
        clearstatcache();
        $total += @filesize($data_file.$i);
	}
	return $total;

}

#
# Since the progress bar is in html, so it needs to refresh itself periodicaly to
# obtain new values. The refresh url with the query string is generated by this
# function.

function make_url()
{
global $iRead,$iTotal,$iMode,$status,$sessionid,$dtnow,$dtstart;
    $parts=array(
    'iTotal='.$iTotal,
    'iRead='.$iRead,
    'iStatus='.$status,
    'iMode='.$iMode,
    //'dtnow='.$dtnow,
    'dtstart='.$dtstart,
    'sessionid='.$sessionid,
    );
	return implode('&',$parts);
}

function show_starting()
{
global $status,$iTotal,$iRead,$dtstart,$signal_file,$callback;

	if(($iTotal = readFlength()) > 0 || @file_exists($signal_file))
	{
		$status=0;
        $iRead = readUploadSize($iNums);
        
        calculateProgress($iTotal,$iRead,$dtstart);
	}

	$url = make_url();

    if($status==0)
    make_progress_bar();
    else
    echo $callback ? trim("$callback('start,$url')") : trim("start,$url");
}

function show_complete()
{
global $status,$iRead,$iTotal,$bSpeedf,$dtelapsed,$dtelapsedf,$fileName,$callback;

	$status=2;
	$url = make_url();

    $iRead = $iTotal;

    # make the the avergae speed!
    if ($bSpeedf == 0) # avoid divide by zero errors
    {
	    $bSpeed = @($iRead / $dtelapsed); # Bytes uploaded / Seconds elapsed = Bytes/Second speed
	    $bitSpeed = $bSpeed * 8; # bps
	    $kbitSpeed = $bSpeed; # Kbps
        $bSpeedf = sprintf("%d",$kbitSpeed); # remove decimals
    }
    $fileName = PHPunescape($fileName);
    echo $callback ? trim("$callback('$iRead:$fileName,$iTotal,00:00:00,$dtelapsedf,$bSpeedf,100,')") :
         trim("$iRead:$fileName,$iTotal,00:00:00,$dtelapsedf,$bSpeedf,100,");
}

function make_progress_bar()
{
global $iRead,$iTotal,$dtRemainingf,$dtelapsedf,$bSpeedf,$percent,$fileName,$callback;

	$url = make_url();
    $fileName = PHPunescape($fileName);
    echo $callback ? trim("$callback('$iRead:$fileName,$iTotal,$dtRemainingf,$dtelapsedf,$bSpeedf,$percent,$url')") :
         trim("$iRead:$fileName,$iTotal,$dtRemainingf,$dtelapsedf,$bSpeedf,$percent,$url");
}
?>